/* GESTOR_CONSULTAS*/
CREATE OR REPLACE
PROCEDURE altaC1(
n_contrato            IN NUMBER,
n_pContratada         IN NUMBER,
n_tpConsumo           IN NUMBER,
n_mConsumo            IN NUMBER,
n_anyo                IN NUMBER,
n_mes                 IN NUMBER,
rst OUT VARCHAR2
)
IS
/******************************************************************************
NOMBRE: altaC1 
PROPSITO: Alta registro en la tabla C1
PARAMETERS: n_contrato, n_pContratada , n_tpConsumo, n_mConsumo, n_anyo, n_mes,rst
INPUT:      n_contrato, n_pContratada , n_tpConsumo, n_mConsumo, n_anyo, n_mes
OUTPUT: ,rst
RETORNA: 'OK' si la operacin ha tenido exito, 'ERROR: Tipo de Error' en caso contrario
EJEMPLO DE USO: altaC1(1,12,12.30,12,2011,7, rst);
******************************************************************************/
contrato_test           INTEGER;
err_msg                 VARCHAR2(100);
dup_contrato            EXCEPTION;
dup_null                EXCEPTION;

BEGIN

--verificamos que los campos no nulos no sean nulos
IF (n_contrato        IS NULL)
OR (n_pContratada     IS NULL)
OR (n_tpConsumo       IS NULL)
OR (n_mConsumo        IS NULL)
OR (n_anyo            IS NULL)
OR (n_mes             IS NULL)
THEN RAISE dup_null;
END IF;
-- comprobar contrato
SELECT COUNT(*)
INTO contrato_test
FROM contratos
WHERE
contratos.id = n_contrato;
IF      (contrato_test = 0)
   THEN RAISE dup_contrato;
END IF;
--insertamos en la tabla de C1 contadoresCiudadFecha
INSERT INTO C1 ( contrato, pContratada, tpConsumo, mConsumo, anyo, mes )
VALUES ( n_contrato, n_pContratada, n_tpConsumo, n_mConsumo, n_anyo, n_mes); 
-- Fin de las operaciones
      rst:='Ok, C1 con exito';
      DBMS_OUTPUT.PUT_LINE('');
      DBMS_OUTPUT.PUT_LINE(rst);
       DBMS_OUTPUT.PUT_LINE(
  'n_contrato: '
 || n_contrato
 || ' n_pContratada: '
 || n_pContratada
 || ' n_tpConsumo: '
 ||n_tpConsumo 
 || ' n_mConsumo: '
 ||  n_mConsumo
 || ' n_anyo: ' 
 || n_anyo
 );
    
altaLog('Proc. altaC1', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
 'n_contrato: '
 || n_contrato
 || ' n_pContratada: '
 || n_pContratada
 || ' n_tpConsumo: '
 ||n_tpConsumo 
 || ' n_mConsumo: '
 ||  n_mConsumo
 || ' n_anyo: ' 
 || n_anyo
  || ' n_mes: ' 
 || n_mes
, 'rst', rst, rst);

COMMIT;
-- controlamos las excepciones
EXCEPTION

WHEN dup_contrato
THEN
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('');
    DBMS_OUTPUT.PUT_LINE(
 'n_contrato: '
 || n_contrato
 || ' n_pContratada: '
 || n_pContratada
 || ' n_tpConsumo: '
 ||n_tpConsumo 
 || ' n_mConsumo: '
 ||  n_mConsumo
 || ' n_anyo: ' 
 || n_anyo
  || ' n_mes: ' 
 || n_mes
  ); 
     rst := 'ERROR: No existe el contrato';
    DBMS_OUTPUT.PUT_LINE('');  
    DBMS_OUTPUT.PUT_LINE(rst);
    
altaLog('Proc. altaC1', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
 'n_contrato: '
 || n_contrato
 || ' n_pContratada: '
 || n_pContratada
 || ' n_tpConsumo: '
 ||n_tpConsumo 
 || ' n_mConsumo: '
 ||  n_mConsumo
 || ' n_anyo: ' 
 || n_anyo
  || ' n_mes: ' 
 || n_mes

, 'rst', rst, rst);
ROLLBACK;
WHEN dup_null
THEN
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('');
    rst := 'ERROR: hay campos no nulos  sin contenido';
    DBMS_OUTPUT.PUT_LINE('');  
    DBMS_OUTPUT.PUT_LINE(rst);
altaLog('Proc. altaC1', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
 'n_contrato: '
 || n_contrato
 || ' n_pContratada: '
 || n_pContratada
 || ' n_tpConsumo: '
 ||n_tpConsumo 
 || ' n_mConsumo: '
 ||  n_mConsumo
 || ' n_anyo: ' 
 || n_anyo
  || ' n_mes: ' 
 || n_mes

, 'rst', rst, rst);
ROLLBACK;
WHEN OTHERS
THEN
err_msg := SUBSTR (SQLERRM, 1, 100);
rst := 'ERROR:'
|| err_msg;
altaLog('Proc. altaC1', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
 'n_contrato: '
 || n_contrato
 || ' n_pContratada: '
 || n_pContratada
 || ' n_tpConsumo: '
 ||n_tpConsumo 
 || ' n_mConsumo: '
 ||  n_mConsumo
 || ' n_anyo: ' 
 || n_anyo
  || ' n_mes: ' 
 || n_mes
, 'rst', rst, rst);
ROLLBACK;
END altaC1;
/
/*
--prueba de uso
declare rst varchar2(250);
begin
--n_contrato, n_pContratada , n_tpConsumo, n_mConsumo, n_anyo, n_mes
altaC1(1,12,12.30,12,2011,7, rst);
end;
*/
CREATE OR REPLACE
PROCEDURE altaC2(
n_central		IN NUMBER,
n_ubica    	IN NUMBER,
n_eEmitida		IN NUMBER,
n_eMax 		IN NUMBER,
rst OUT VARCHAR2
)
IS
/******************************************************************************
NOMBRE:  altaC2 
PROPSITO:  consultarCentralesDistribucionMasEnergia
PARAMETERS: n_central,n_ubica,n_eEmitida,n_eMax ,rst
INPUT:  n_central,n_ubica,n_eEmitida,n_eMax 
RETORNA: 'OK' si la operacin ha tenido exito, 'ERROR: Tipo de Error' en caso contrario
EJEMPLO DE USO: altaC2(1,10,10,30, rst);
******************************************************************************/

err_msg             VARCHAR2(100);

central_test	INTEGER;
ubica_test		INTEGER;
dup_central       EXCEPTION;
dup_ubica		EXCEPTION;
dup_null        EXCEPTION;
            
BEGIN


--verificamos que los campos no nulos no sean nulos
IF (n_central		IS NULL)
OR (n_ubica		IS NULL)
OR (n_eEmitida		IS NULL)
OR (n_eMax 		IS NULL)

THEN RAISE dup_null;
END IF;

-- verificar central y ubicacin 

SELECT count(*)
INTO central_test
FROM centrales
WHERE 
centrales.id = n_central;
IF (central_test = 0)
THEN
RAISE dup_central;
END IF;

SELECT count(*)
INTO ubica_test
FROM ubicaciones
WHERE 
ubicaciones.id = n_ubica;
IF (ubica_test = 0)
THEN
RAISE dup_ubica;
END IF;


 DBMS_OUTPUT.ENABLE;
 DBMS_OUTPUT.PUT_LINE('');
 DBMS_OUTPUT.PUT_LINE('consultarCentralesDistribucionMasEnergia' 
||' n_central:'
||n_central
||' n_ubica'
|| n_central
|| ' n_eEmitida:'
|| n_eEmitida
|| ' n_eMax :'
|| n_eMax 
) ;
 DBMS_OUTPUT.PUT_LINE('-----------------------------------------------------');
 DBMS_OUTPUT.PUT_LINE('');
  

--insertamos en la tabla de C3 
 
INSERT INTO C2 (central,ubica,eEmitida,eMax)  
VALUES(n_central,n_ubica,n_eEmitida,n_eMax );

-- Fin de las operaciones
 
    rst:='Ok, AltaconsultarCentralesDistribucionMasEnergia';
       
altaLog('Proc. altaC2', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
' n_central:'
||n_central
||' n_ubica'
|| n_central
|| ' n_eEmitida:'
|| n_eEmitida
|| ' n_eMax :'
|| n_eMax 
, 'rst', rst, rst);

COMMIT;

-- controlamos las excepciones
EXCEPTION

WHEN dup_central
THEN

    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('');
    DBMS_OUTPUT.PUT_LINE('consultarClientesContadoresAltaDisponibiliad' 
||' n_central:'
||n_central
||' n_ubica'
|| n_central
|| ' n_eEmitida:'
|| n_eEmitida
|| ' n_eMax :'
|| n_eMax 
) ;
    rst := 'ERROR: No hay central';
    DBMS_OUTPUT.PUT_LINE('');  
    DBMS_OUTPUT.PUT_LINE(rst);
    
altaLog('Proc. altaC2', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
' n_central:'
||n_central
||' n_ubica'
|| n_central
|| ' n_eEmitida:'
|| n_eEmitida
|| ' n_eMax :'
|| n_eMax 
, 'rst', rst, rst);

ROLLBACK;


WHEN dup_null
THEN
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('');
    rst := 'ERROR: hay campos no nulos  sin contenido';
    DBMS_OUTPUT.PUT_LINE('');  
    DBMS_OUTPUT.PUT_LINE(rst);
  
altaLog('Proc. altaC2', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
' n_central:'
||n_central
||' n_ubica'
|| n_central
|| ' n_eEmitida:'
|| n_eEmitida
|| ' n_eMax :'
|| n_eMax 
, 'rst', rst, rst);

ROLLBACK;

WHEN dup_ubica
THEN
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('');
    rst := 'ERROR: No hay ubicacion';
    DBMS_OUTPUT.PUT_LINE('');  
    DBMS_OUTPUT.PUT_LINE(rst);
  
altaLog('Proc. altaC2', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
' n_central:'
||n_central
||' n_ubica'
|| n_central
|| ' n_eEmitida:'
|| n_eEmitida
|| ' n_eMax :'
|| n_eMax 
, 'rst', rst, rst);

ROLLBACK;


ROLLBACK;
WHEN OTHERS
THEN
err_msg := SUBSTR (SQLERRM, 1, 100);
rst := 'ERROR:'
|| err_msg;
altaLog('Proc. altaC2', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
' n_central:'
||n_central
||' n_ubica'
|| n_central
|| ' n_eEmitida:'
|| n_eEmitida
|| ' n_eMax :'
|| n_eMax 
, 'rst', rst, rst);
ROLLBACK;
END altaC2;
/
CREATE OR REPLACE
PROCEDURE altaC3(
n_linea               IN NUMBER,
n_cLinea              IN NUMBER,
n_eAmplia             IN NUMBER,
rst OUT VARCHAR2
)
IS
/******************************************************************************
NOMBRE:  altaC3 
PROPSITO:  alta en la tabla C3
PARAMETERS: n_linea,n_cLinea,n_eAmplia,rst
INPUT:  n_linea,n_cLinea,n_eAmplia
RETORNA: 'OK' si la operacin ha tenido exito, 'ERROR: Tipo de Error' en caso contrario
EJEMPLO DE USO: altaC3(1,20,30, rst);
******************************************************************************/

err_msg             VARCHAR2(100);

linea_test		INTEGER;
max_test		INTEGER;

dup_linea       EXCEPTION;
dup_max		EXCEPTION;
dup_null        EXCEPTION;
            
BEGIN


--verificamos que los campos no nulos no sean nulos
IF (n_linea   			IS NULL)
OR (n_cLinea              IS NULL)
OR (n_eAmplia             IS NULL)

THEN RAISE dup_null;
END IF;

-- verificar linea y carga mxima de lnea

SELECT count(*)
INTO linea_test
FROM linea
WHERE 
linea.id = n_linea;
IF (linea_test = 0)
THEN
RAISE dup_linea;
END IF;

SELECT count(*)
INTO max_test
FROM linea
WHERE 
linea.cMax <  n_cLinea;
IF (max_test = 1)
THEN
RAISE dup_max;
END IF;

/*-- solo en fase de desarrollo para comprobar la salida
 DBMS_OUTPUT.ENABLE;
 DBMS_OUTPUT.PUT_LINE('');
 DBMS_OUTPUT.PUT_LINE('consultarLineasMasCargadasCapacidadMaxima' 
||' n_linea:'
||n_linea
||' n_cLinea'
|| n_cLinea
|| ' n_eAmplia:'
|| n_eAmplia
) ;
 DBMS_OUTPUT.PUT_LINE('-----------------------------------------------------');
 DBMS_OUTPUT.PUT_LINE('');
*/

--insertamos en la tabla de C3 
 
INSERT INTO C3 (
 linea,cLinea, eAmplia)  
VALUES(n_linea,n_cLinea,n_eAmplia);

-- Fin de las operaciones
 
    rst:='Ok, alta C3: AltaconsultarLineasMasCargadasCapacidadMaxima';
    DBMS_OUTPUT.PUT_LINE('--------------------------------------------');
    DBMS_OUTPUT.PUT_LINE(rst);  
    DBMS_OUTPUT.PUT_LINE('---------------------------------------------');
 
       
altaLog('Proc. altaC3', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
' n_linea:'
||n_linea
||' n_cLinea'
|| n_cLinea
|| ' n_eAmplia:'
|| n_eAmplia
, 'rst', rst, rst);

COMMIT;

-- controlamos las excepciones
EXCEPTION

WHEN dup_null
THEN
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('');
    rst := 'ERROR: hay campos no nulos  sin contenido';
    DBMS_OUTPUT.PUT_LINE('');  
    DBMS_OUTPUT.PUT_LINE(rst);
  
altaLog('Proc. altaC3', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
' n_linea:'
||n_linea
||' n_cLinea'
|| n_cLinea
|| ' n_eAmplia:'
|| n_eAmplia
, 'rst', rst, rst);

ROLLBACK;

WHEN dup_linea
THEN
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('');
    rst := 'ERROR: No hay linea';
    DBMS_OUTPUT.PUT_LINE('');  
    DBMS_OUTPUT.PUT_LINE(rst);
  
altaLog('Proc. altaC3', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
' n_linea:'
||n_linea
||' n_cLinea'
|| n_cLinea
|| ' n_eAmplia:'
|| n_eAmplia
, 'rst', rst, rst);

ROLLBACK;

WHEN dup_max
THEN
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('');
    rst := 'ERROR: Sobrepasa la carga mxima de linea';
    DBMS_OUTPUT.PUT_LINE('');  
    DBMS_OUTPUT.PUT_LINE(rst);
  
altaLog('Proc. altaC3', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
' n_linea:'
||n_linea
||' n_cLinea'
|| n_cLinea
|| ' n_eAmplia:'
|| n_eAmplia
, 'rst', rst, rst);

ROLLBACK;
WHEN OTHERS
THEN
err_msg := SUBSTR (SQLERRM, 1, 100);
rst := 'ERROR:'
|| err_msg;
altaLog('Proc. altaC3', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
' n_linea:'
||n_linea
||' n_cLinea'
|| n_cLinea
|| ' n_eAmplia:'
|| n_eAmplia
, 'rst', rst, rst);
ROLLBACK;
END altaC3;
/
CREATE OR REPLACE
PROCEDURE altaC4(
n_dni		          IN VARCHAR2,
n_contrato            IN NUMBER,
n_modelo			IN NUMBER,
rst OUT VARCHAR2
)
IS
/******************************************************************************
NOMBRE:  altaC4 
PROPSITO:  consultarClientesContadoresAltaDisponibiliad 
PARAMETERS: n_dni,n_contrato,n_modelo ,rst
INPUT:  n_dni,n_contrato,n_modelo
RETORNA: 'OK' si la operacin ha tenido exito, 'ERROR: Tipo de Error' en
caso contrario
EJEMPLO DE USO: altaC4('48023076',1,1, rst);
******************************************************************************/
n_dni_ins      VARCHAR2(10);

err_msg             VARCHAR2(100);

dni_test	INTEGER;
contrato_test	INTEGER;
modelo_test	INTEGER;
dup_dni           EXCEPTION;
dup_contrato		EXCEPTION;
dup_modelo			EXCEPTION;
dup_null            EXCEPTION;
            
BEGIN

--comprobamos la longitud de las cadenas
n_dni_ins   := SUBSTR (n_dni, 1, 10);

--verificamos que los campos no nulos no sean nulos
IF (n_dni_ins   IS NULL)
OR (n_contrato   IS NULL)
OR (n_modelo   IS NULL)

THEN RAISE dup_null;
END IF;

-- verificar dni, contrato y modelo

SELECT count(*)
INTO dni_test
FROM clientes
WHERE 
clientes.NIFCIF = n_dni;
IF (dni_test = 0)
THEN
RAISE dup_dni;
END IF;

SELECT count(*)
INTO contrato_test
FROM contratos
WHERE 
contratos.id = n_contrato;
IF (contrato_test = 0)
THEN
RAISE dup_contrato;
END IF;

SELECT count(*)
INTO modelo_test
FROM modelos
WHERE 
modelos.id = n_modelo;
IF (modelo_test = 0)
THEN
RAISE dup_modelo;
END IF;


 DBMS_OUTPUT.ENABLE;
 DBMS_OUTPUT.PUT_LINE('');
 DBMS_OUTPUT.PUT_LINE('consultarClientesContadoresAltaDisponibiliad' 
||' n_dni:'
||n_dni
||' n_contrato'
|| n_contrato
|| ' n_modelo:'
|| n_modelo
) ;
 DBMS_OUTPUT.PUT_LINE('-----------------------------------------------------');
 DBMS_OUTPUT.PUT_LINE('');
  

--insertamos en la tabla de C4 
 
INSERT INTO C4 (dni,contrato,modelo)
VALUES(n_dni_ins,n_contrato,n_modelo);

-- Fin de las operaciones
 
    rst:='Ok, Alta consultarClientesContadoresAltaDisponibiliad';
       
altaLog('Proc. altaC4', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
' n_dni:'
||n_dni
||' n_contrato'
|| n_contrato
|| ' n_modelo:'
|| n_modelo
, 'rst', rst, rst);

COMMIT;

-- controlamos las excepciones
EXCEPTION

WHEN dup_contrato
THEN

    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('');
    DBMS_OUTPUT.PUT_LINE('consultarClientesContadoresAltaDisponibiliad' 
||' n_dni:'
||n_dni
||' n_contrato'
|| n_contrato
|| ' n_modelo:'
|| n_modelo
) ;
    rst := 'ERROR: No hay contrato';
    DBMS_OUTPUT.PUT_LINE('');  
    DBMS_OUTPUT.PUT_LINE(rst);
    
altaLog('Proc. altaC4', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
' n_dni:'
||n_dni
||' n_contrato'
|| n_contrato
|| ' n_modelo:'
|| n_modelo
, 'rst', rst, rst);

ROLLBACK;


WHEN dup_null
THEN
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('');
    rst := 'ERROR: hay campos no nulos  sin contenido';
    DBMS_OUTPUT.PUT_LINE('');  
    DBMS_OUTPUT.PUT_LINE(rst);
  
altaLog('Proc. altaC4', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
' n_dni:'
||n_dni
||' n_contrato'
|| n_contrato
|| ' n_modelo:'
|| n_modelo
, 'rst', rst, rst);

ROLLBACK;

WHEN dup_modelo
THEN
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('');
    rst := 'ERROR: No hay modelo';
    DBMS_OUTPUT.PUT_LINE('');  
    DBMS_OUTPUT.PUT_LINE(rst);
  
altaLog('Proc. altaC4', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
' n_dni:'
||n_dni
||' n_contrato'
|| n_contrato
|| ' n_modelo:'
|| n_modelo
, 'rst', rst, rst);

ROLLBACK;

WHEN OTHERS
THEN
err_msg := SUBSTR (SQLERRM, 1, 100);
rst := 'ERROR:'
|| err_msg;
altaLog('Proc. altaC4', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
' n_dni:'
||n_dni
||' n_contrato'
|| n_contrato
|| ' n_modelo:'
|| n_modelo
, 'rst', rst, rst);
ROLLBACK;
END altaC4;
/
CREATE OR REPLACE
PROCEDURE altaC5(
n_id         	IN NUMBER,
n_contador		IN NUMBER,
n_consumo		IN NUMBER,
n_eProd		IN NUMBER,
n_ini		  	IN VARCHAR2,
n_fin		  	IN VARCHAR2,
rst OUT VARCHAR2
)
IS
/******************************************************************************
NOMBRE:  altaC5 
PROPSITO:  Alta en la tabla C5
PARAMETERS: n_id, n_contador, n_consumo, n_eProd, n_ini, n_fin ,rst
INPUT:    n_id, n_contador, n_consumo, n_eProd, n_ini, n_fin 
OUTPUT:     rst
RETORNA:    'OK' si la operacin ha tenido exito, 'ERROR: Tipo de Error' en caso contrario
EJEMPLO DE USO: altaC5(1,2,30,40,'01/01/2012','01/06/2012', rst);
******************************************************************************/
n_ini_ins   VARCHAR2(11);
n_fin_ins   VARCHAR2(11);

err_msg             VARCHAR2(100);
dup_null            EXCEPTION;
            
BEGIN

--comprobamos la longitud de las cadenas
n_ini_ins   := SUBSTR (n_ini, 1, 11);
n_fin_ins   := SUBSTR (n_fin, 1, 11);


--verificamos que los campos no nulos no sean nulos
IF (n_id IS NULL)
OR ( n_contador  IS NULL)
OR  (n_consumo  IS NULL)
OR  (n_eProd  IS NULL)
OR ( n_ini_ins IS NULL)
OR  (n_fin_ins  IS NULL)
THEN RAISE dup_null;
END IF;

  
--insertamos en la tabla de C5 
 
INSERT INTO C5 (central, contador, consumo, eProd, pInicial ,pFinal)
VALUES(n_id, n_contador,n_consumo,n_eProd ,n_ini_ins,n_fin_ins);

-- Fin de las operaciones
 
    rst:='OK, Alta C5';
    DBMS_OUTPUT.PUT_LINE('');  
    DBMS_OUTPUT.PUT_LINE(rst);
       
altaLog('Proc. altaC5', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
' n_id'
|| n_id
||'  n_contador: '
|| n_contador
||'  n_consumo  : '
|| n_consumo
, 'rst', rst, rst);

COMMIT;

-- controlamos las excepciones
EXCEPTION


WHEN dup_null
THEN
    DBMS_OUTPUT.PUT_LINE('');
    rst := 'ERROR: hay campos no nulos  sin contenido';
    DBMS_OUTPUT.PUT_LINE('');  
    DBMS_OUTPUT.PUT_LINE(rst);
  
altaLog('Proc. altaC5', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
' n_id'
|| n_id
||'  n_contador: ' 
|| n_contador 
||'  n_consumo  : '
|| n_consumo
, 'rst', rst, rst);

ROLLBACK;
WHEN OTHERS
THEN
err_msg := SUBSTR (SQLERRM, 1, 100);
rst := 'ERROR:'
|| err_msg;
altaLog('Proc. altaC5', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
' n_id'
|| n_id
||'  n_contador: ' 
|| n_contador 
||'  n_consumo  : '
|| n_consumo
, 'rst', rst, rst);
ROLLBACK;
END altaC5;
/
CREATE OR REPLACE
PROCEDURE altaC7(
n_contador	   IN NUMBER,
n_anyo             IN NUMBER,
n_fabrica          IN VARCHAR2,
rst OUT VARCHAR2
)
IS
/******************************************************************************
NOMBRE:  altaC7 
PROPSITO:  alta en la tabla de consultas C7: contadores, aos de antiguedad 
PARAMETERS: n_contador, n_anyo, n_fabrica , sysdate,rst
INPUT:  n_contador, n_anyo, n_fabrica
RETORNA: 'OK' si la operacin ha tenido xito, 'ERROR: Tipo de Error' en caso contrario
EJEMPLO DE USO: altaC7(2,7,'1997', rst);
******************************************************************************/
err_msg       VARCHAR2(100);
contador_test INTEGER;
dup_contador  EXCEPTION;
dup_null            EXCEPTION;
 
 
            
BEGIN

--verificamos que los campos no nulos no sean nulos
IF (n_contador   IS NULL)
OR (n_anyo   IS NULL)
THEN RAISE dup_null;
END IF;

-- verificar que existe el contador
SELECT count(*)
INTO contador_test
FROM contadores
WHERE 
contadores.id = n_contador;
IF (contador_test = 0)
THEN
RAISE dup_contador;
END IF;

--insertamos en la tabla de C7 
 
INSERT INTO C7 (contador, anyos,fabrica, fechaConsulta)
VALUES(n_contador, n_anyo, n_fabrica,to_char(sysdate,'DD/MM/YYYY'));


-- Fin de las operaciones
 
    rst:='Ok, alta C7 Alta consultarContadoresAntiguedad';
    DBMS_OUTPUT.PUT_LINE('--------------------------------------------');
    DBMS_OUTPUT.PUT_LINE(rst);  
    DBMS_OUTPUT.PUT_LINE('---------------------------------------------');

       
altaLog('Proc. altaC7', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
' n_contador:'
||n_contador
||' n_anyo'
|| n_anyo
|| ' n_fabrica'
|| n_fabrica
, 'rst', rst, rst);

COMMIT;

-- controlamos las excepciones
EXCEPTION

WHEN dup_contador
THEN

    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('');
    DBMS_OUTPUT.PUT_LINE('ERROR: No existe el contador' 
||' n_contador:'
||n_contador
||' n_anyo'
|| n_anyo
|| ' n_fabrica'
|| n_fabrica
) ;
    rst := 'ERROR: No existe el contador';
    DBMS_OUTPUT.PUT_LINE('');  
    DBMS_OUTPUT.PUT_LINE(rst);
    
altaLog('Proc. altaC7', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
' n_contador:'
||n_contador
||' n_anyo'
|| n_anyo
|| ' n_fabrica'
|| n_fabrica
, 'rst', rst, rst);

ROLLBACK;
WHEN dup_null
THEN
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('');
    rst := 'ERROR: hay campos no nulos  sin contenido';
    DBMS_OUTPUT.PUT_LINE('');  
    DBMS_OUTPUT.PUT_LINE(rst);
  
altaLog('Proc. altaC7', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
' n_contador:'
||n_contador
||' n_anyo'
|| n_anyo
|| ' n_fabrica'
|| n_fabrica
, 'rst', rst, rst);

ROLLBACK;

WHEN OTHERS
THEN
err_msg := SUBSTR (SQLERRM, 1, 100);
rst := 'ERROR:'
|| err_msg;
altaLog('Proc. altaC7', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
' n_contador:'
||n_contador
||' n_anyo'
|| n_anyo
|| 'n_fabrica'
|| n_fabrica
, 'rst', rst, rst);
ROLLBACK;
END altaC7;
/
CREATE OR REPLACE
PROCEDURE consultaC1(
n_localidad_des   IN VARCHAR2,
n_anyo        IN NUMBER,
n_mes         IN NUMBER,
rst OUT VARCHAR2
)
IS
/******************************************************************************
NOMBRE: consultaC1 
PROPSITO: Dada una ciudad y una fecha , los contadores donde el consumo mensual en la fecha 
supere  el 80% del consumo medio de todos los contadores de la ciudad en ese periodoDonada una ciutat i una data com a parmetres, el llistat de

        Codi de contracte.
        La potncia mxima contractada.
        El tant per cent de consum elctric consumit en relaci al consum mitj.
        Tot aix ordenat de forma ascendent pel tant per cent de consum elctric consumit.
PARAMETERS: n_anyos,rst
INPUT: n_localidad_des, anyo, n_mes
OUTPUT: n_localidad_des, anyo, n_mes ,rst
RETORNA: 'OK' si la operacin ha tenido exito, 'ERROR: Tipo de Error' en caso contrario
EJEMPLO DE USO: consultaC1('TERRASSA',2011,7, rst);
******************************************************************************/

localidad_test    INTEGER;
n_contrato        NUMERIC;
n_potencia        NUMERIC;
n_contador        NUMERIC;
n_consumo         NUMERIC; 
n_tpConsumo       NUMERIC(9,2);
n_mConsumo        NUMERIC(9,2);
n_localidad_des_ins VARCHAR2(50);
err_msg           VARCHAR2(100);
dup_localidad    EXCEPTION;
dup_null         EXCEPTION;

CURSOR C1 IS
select distinct contratos.ID , contratos.PCONTRATO , contratos.CONTADOR, sum(consumos.consumo) --(distinct contadores.ID)
from contadores, consumos, lineas, linea, contratos, localidad
WHERE 
contadores.ESTADO  = 1 -- activos
and localidad.ID =  localidad_test             -- de la localidad
and linea.id = lineas.LINEA
and lineas.C2 = consumos.CONTADOR               -- que esten conectados y tengan consumo
and contratos.CONTADOR = consumos.CONTADOR      --con contrato
and consumos.ANYO = n_anyo
and consumos.MES =  n_mes
group by contratos.ID,contratos.PCONTRATO,contratos.CONTADOR,(consumos.consumo)
having sum(consumos.CONTADOR) > 0
order by sum(consumos.consumo) asc; --en forma ascendent

-----------------------------------------

BEGIN
n_localidad_des_ins :=  SUBSTR (n_localidad_des, 1, 50);
--verificamos que los campos no nulos no sean nulos
    IF  (n_localidad_des  IS NULL)
    OR  (n_anyo        IS NULL)
    OR  (n_mes         IS NULL)
THEN RAISE dup_null;
END IF;


--obtener el cdigo de la localidad

SELECT localidad.ID
INTO localidad_test
FROM localidad
WHERE
localidad.DES = n_localidad_des;
IF      (localidad_test = 0)
   THEN RAISE dup_localidad;
END IF;
  
 OPEN c1;
               FETCH C1  INTO n_contrato, n_potencia, n_contador, n_consumo ;

                WHILE (c1%FOUND) --and (getConsumoContadorFecha(n_contador,n_anyo,n_mes) > 0.8*getConsumoMedioLocalidadFecha(n_localidad,n_anyo,n_mes)))
                 LOOP                  
                      FETCH C1   INTO n_contrato, n_potencia, n_contador, n_consumo ;

--actualizo variables con las operaciones
 n_tpConsumo  := 100*getConsumoContadorFecha(n_contador,n_anyo,n_mes)/getConsumoMedioLocalidadFecha(localidad_test,n_anyo,n_mes);
 n_mConsumo   := getConsumoContadorFecha(n_contador,n_anyo,n_mes);
 
--n_contrato, n_pContratada , n_tpConsumo, n_mConsumo, n_anyo, n_mes
 altaC1(n_contrato, n_potencia, n_tpConsumo,n_mConsumo,n_anyo, n_mes,rst);
 
  DBMS_OUTPUT.ENABLE(250);
  DBMS_OUTPUT.PUT_LINE('-----------------------------------------------------');
  DBMS_OUTPUT.PUT_LINE(
 ' Codigo contrato: '
 ||n_contrato
 || ' Potencia contratada: '
 || n_potencia
 || ' % consumo respecto consumo medio : '
 || n_tpConsumo
 ||' Consumo contador: '
 ||n_mConsumo
 || ' Anyo: '
 || n_anyo
 || ' Mes: '
 || n_mes);
               END LOOP;
          CLOSE c1;
--end cursorLocalidad;
-- Fin de las operaciones
    rst:='Ok, Alta C1   realizada con exito';
 altaLog('Proc. altaC1', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
'n_contador: ' 
|| n_contador 
||'n_anyo  : '
|| n_anyo
, 'rst', rst, rst);

COMMIT;
-- controlamos las excepciones
EXCEPTION
WHEN dup_localidad
THEN
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('');
    rst := 'ERROR: NO existe la localidad';
    DBMS_OUTPUT.PUT_LINE('');  
    DBMS_OUTPUT.PUT_LINE(rst);
altaLog('Proc. altaC1', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
'n_localidad' 
|| localidad_test
|| 'n_fecha'
|| n_anyo
, 'rst', rst, rst);
ROLLBACK;

WHEN dup_null
THEN
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('');
    rst := 'ERROR: hay campos no nulos  sin contenido';
    DBMS_OUTPUT.PUT_LINE('');  
    DBMS_OUTPUT.PUT_LINE(rst);
altaLog('Proc. altaC1', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
'n_localidad' 
|| localidad_test
|| 'n_fecha'
|| n_anyo
, 'rst', rst, rst);
ROLLBACK;

WHEN OTHERS
THEN
err_msg := SUBSTR (SQLERRM, 1, 100);
rst := 'ERROR:'
|| err_msg;
altaLog('Proc. altaC1', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
'n_anyos ' || n_anyo 
, 'rst', rst, rst);
ROLLBACK;
END consultaC1;
/
CREATE OR REPLACE
PROCEDURE consultaC3(
n_top       IN INTEGER,
rst OUT VARCHAR2
)
IS
/******************************************************************************
NOMBRE:  consultaC3 
PROPSITO:  Consulta de las 10 lineas ms cargadas en relacin a su capacidad mxima
PARAMETERS: n_linea,n_cLinea,n_eAmplia,rst
INPUT:  n_linea,n_cLinea,n_eAmplia
RETORNA: 'OK' si la operacin ha tenido exito, 'ERROR: Tipo de Error' en caso contrario
EJEMPLO DE USO: consultaC3(10, rst);
******************************************************************************/

err_msg           VARCHAR2(100);
linea_test	  INTEGER;
n_id              NUMBER;
n_consumo         NUMBER(9,2);
n_amplia          NUMBER(9,2);
dup_null          EXCEPTION;
  

CURSOR c1 IS
Select linea.id, 100*getLineaConsumo(linea.id)/getLineaCmax(linea.id), getLineaCmax(linea.id)-getLineaConsumo(linea.id)
from linea
group by linea.id, linea.CMAX
order by linea.CMAX;

BEGIN

-- abrimos el cursor para actualizar los resultados
OPEN c1;
               FETCH c1 INTO n_id, n_consumo, n_amplia ;
               WHILE (c1%FOUND and ( c1%ROWCOUNT <= n_top)) LOOP  
                   FETCH c1 INTO n_id, n_consumo, n_amplia ;
                      DBMS_OUTPUT.PUT_LINE(' linea: ' || n_id ||' porcentaje ocupacin  : '|| n_consumo ||' puede ampliar:  '  || n_amplia ||' KW' );
                      rst :='OK, alta C3';
                      altaC3(n_id, n_consumo, n_amplia,rst);
                  END LOOP;
       CLOSE c1;

-- Fin de las operaciones
 
    rst:='OK';
       
altaLog('Proc. consultaC3', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
' n_id:'
||n_id
||' tanto por ciento '
|| n_consumo
|| ' n_amplia'
|| n_amplia
, 'rst', rst, rst);

COMMIT;

-- controlamos las excepciones
EXCEPTION


WHEN OTHERS
THEN
err_msg := SUBSTR (SQLERRM, 1, 100);
rst := 'ERROR:'
|| err_msg;
altaLog('Proc. consultaC3', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
' n_id:'
||n_id
||' tanto por ciento '
|| n_consumo
|| ' n_amplia'
|| n_amplia

, 'rst', rst, rst);
ROLLBACK;
END consultaC3;
/
CREATE OR REPLACE
PROCEDURE consultaC5(
n_central        IN NUMBER,
n_ini            IN VARCHAR2,
n_fin            IN VARCHAR2,
rst OUT VARCHAR2
)
IS
/******************************************************************************
NOMBRE:  consultaC5 
PROPSITO:  Dada una central de produccin y un intervalo de tiempo,
            consumo producido por los contadores que dependen de la central
            y la energia producida por la central en el periodo de tiempo.
PARAMETERS: n_central, n_pInicial, n_pFinal ,rst
INPUT:      n_central, n_pInicial, n_pFinal 
OUTPUT:     rst
RETORNA:    'OK' si la operacin ha tenido xito, 'ERROR: Tipo de Error' en caso contrario
EJEMPLO DE USO: consultaC5(1,'01/01/2010','01/07/2012', rst);
******************************************************************************/
n_ini_ins   VARCHAR2(11);
n_fin_ins   VARCHAR2(11);
n_aIni      Varchar2(4);
n_aFin      VARCHAR2(4);
n_mIni      VARCHAR2(2);
n_mFin      VARCHAR2(2);

nn_aIni number;
nn_aFin number;
nn_mIni number;
nn_mFin number;

prod_test           INTEGER;
central_test        INTEGER;
contador_test       INTEGER;
contador            INTEGER;
n_contador          NUMBER;
n_central_ins       NUMBER;
n_consumo           NUMBER(9,2);
eProd               NUMBER(9,2);
eProducida               NUMBER(9,2);
err_msg             VARCHAR2(100);

dup_contador        EXCEPTION;
dup_null            EXCEPTION;
 
CURSOR c1 IS 
SELECT  distinct (contadores.ID) ,sum(consumos.CONSUMO), centrales.EMAX ,n_ini,n_fin
FROM
centrales,  contadores , consumos, estados, linea, lineas, modelos
WHERE
    consumos.ANYO BETWEEN nn_aIni and nn_aFin
and consumos.MES  BETWEEN nn_mIni and nn_mFin
and centrales.ID  = lineas.C1
and contadores.ID = lineas.C2
and contadores.ID = consumos.CONTADOR
and linea.ID      = lineas.LINEA
and estados.ID    = centrales.ESTADO
and estados.ID    = contadores.ESTADO
and estados.ID    = lineas.ESTADO
and estados.ID    = linea.ESTADO
and centrales.ID =  n_central 
group by  contadores.ID,(consumos.CONSUMO),  centrales.EMAX
having sum(consumos.consumo) > 0
order by contadores.id asc;

         
BEGIN
-- inicializar varables
contador := 1;
--comprobamos la longitud de las cadenas
n_ini_ins   := SUBSTR (n_ini, 1, 11);
n_fin_ins   := SUBSTR (n_fin, 1, 11);

n_aIni    := SUBSTR(n_ini_ins, 7, 4);
n_aFin    := SUBSTR(n_fin_ins, 7, 4);
n_mIni    := SUBSTR(n_ini_ins, 5, 1);
n_mFin    := SUBSTR(n_fin_ins, 5, 1);
nn_mIni   := to_number(n_mIni,99);
nn_mFin   := to_number(n_mFin,99);

nn_aIni   := to_number(n_aIni,9999);
nn_aFin   := to_number(n_aFin,9999);

    
-- verificar que existe la central
SELECT count(*)
INTO contador_test
FROM
centrales, linea, lineas, contadores, consumos, estados
WHERE
  
   consumos.ANYO BETWEEN n_aIni and n_aFin
and consumos.MES  BETWEEN nn_mIni and nn_mFin
and centrales.ID  = lineas.C1
and contadores.ID = lineas.C2
and contadores.ID = consumos.CONTADOR
and linea.ID      = lineas.LINEA
and estados.ID    = centrales.ESTADO
and estados.ID    = contadores.ESTADO
and estados.ID    = lineas.ESTADO
and estados.ID    = linea.ESTADO
and  centrales.ID = n_central;

IF (contador_test = 0)
THEN
RAISE dup_contador;
END IF;


eProducida := 0;
  --abrir el cursor e insertar en la tabla correspondiente
        OPEN c1;
               FETCH c1 INTO n_contador, n_consumo, eProd, n_ini_ins, n_fin_ins ;
               WHILE c1%FOUND  LOOP
               FETCH c1 INTO n_contador, n_consumo, eProd, n_ini_ins, n_fin_ins ;
                      DBMS_OUTPUT.ENABLE(250);
                      DBMS_OUTPUT.PUT_LINE(' Central: ' ||n_central||' Contador: ' ||n_contador ||' Consumo contador:  ' ||n_consumo
                      ||' Energia Mxima : ' ||eProd ||' n_ini_ins:  ' ||n_ini_ins ||' n_fin_ins:  ' ||n_fin_ins   );
                     eProducida := eProducida + n_consumo;
                    -- alta registro en la tabla                                  
                     altaC5(n_central, n_contador, n_consumo,  eProducida , n_ini_ins,  n_fin_ins,  rst);
                     END LOOP;
       
       DBMS_OUTPUT.PUT_LINE('------------------------------------------------------------------------------------------------------------------------ '    );
       DBMS_OUTPUT.PUT_LINE('Energia Producida: Central : ' ||n_central ||' , '
       || ' periodo inicial :'
       || n_ini_ins
       || ' ,periodo final :'
       || n_fin_ins
       ||' ,energia producida: '
       || eProducida   );
       DBMS_OUTPUT.PUT_LINE('------------------------------------------------------------------------------------------------------------------------ '    );
       CLOSE c1;

rst :='OK, Proc. consultaC5';     
altaLog('Proc. consultaC5', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
' n_central'
|| n_central
||'  n_contador: '
|| n_contador
||'  n_consumo  : '
|| n_consumo
, 'rst', rst, rst);

COMMIT;

-- controlamos las excepciones
EXCEPTION

WHEN dup_contador
THEN
    DBMS_OUTPUT.PUT_LINE('');
    DBMS_OUTPUT.PUT_LINE('n_central : ' || n_central  ); 
    rst := 'ERROR: La central no tiene contadores conectados';
    DBMS_OUTPUT.PUT_LINE('');  
    DBMS_OUTPUT.PUT_LINE(rst);
    
altaLog('Proc. consultaC5', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
' n_central'
|| n_central
, 'rst', rst, rst);

ROLLBACK;


WHEN dup_null
THEN
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('');
    rst := 'ERROR: hay campos no nulos  sin contenido';
    DBMS_OUTPUT.PUT_LINE('');  
    DBMS_OUTPUT.PUT_LINE(rst);
  
altaLog('Proc. consultaC5', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
' n_central'
|| n_central
||'  n_contador: ' 
|| n_contador 
||'  n_consumo  : '
|| n_consumo
, 'rst', rst, rst);

ROLLBACK;
WHEN OTHERS
THEN
err_msg := SUBSTR (SQLERRM, 1, 100);
rst := 'ERROR:'
|| err_msg;
altaLog('Proc. consultaC5', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
' n_central'
|| n_central
||'  n_contador: ' 
|| n_contador 
||'  n_consumo  : '
|| n_consumo
, 'rst', rst, rst);
ROLLBACK;
END consultaC5;
/
CREATE OR REPLACE
PROCEDURE consultaC6(
n_pInicial          IN VARCHAR2,
n_pFinal            IN VARCHAR2,
rst OUT VARCHAR2
)
IS
/******************************************************************************
NOMBRE:  consultaC6 
PROPSITO:  Consulta para obtener porcentaje de  lecturas de contadores  efectuades de forma
            presencial y de forma telemtica en un perodo de tiempo
PARAMETERS: n_pInicial, n_pFinal ,rst
INPUT:  n_pInicial, n_pFinal
OUTPUT: tTelema,tPresent,n_pTelematica,n_pPresencial,n_total,n_pInicial_ins,n_pFinal_ins,rst
RETORNA: 'OK' si la operacin ha tenido exito, 'ERROR: Tipo de Error' en caso contrario
EJEMPLO DE USO: consultaC6('01/01/2012','01/06/2012', rst);
******************************************************************************/
n_pInicial_ins      VARCHAR2(11);
n_pFinal_ins        VARCHAR2(11);
n_total             NUMBER(9,2);
tPresent            INTEGER;
tTelema             INTEGER;
contador_test       INTEGER;
n_presencial        NUMBER(9,2);
n_telematica        NUMBER(9,2);
n_pPresencial       NUMBER(9,2);
n_pTelematica       NUMBER(9,2);
err_msg             VARCHAR2(100);

dup_total           EXCEPTION;
dup_null            EXCEPTION;
            
BEGIN

--comprobamos la longitud de las cadenas
n_pInicial_ins   := SUBSTR (n_pInicial, 1, 11);
n_pFinal_ins     := SUBSTR (n_pFinal, 1, 11);

--verificamos que los campos no nulos no sean nulos
IF (n_pInicial_ins   IS NULL)
OR (n_pFinal_ins   IS NULL)
THEN RAISE dup_null;
END IF;

-- obtener tipo lectura y el numero de lecturas

SELECT tLectura.id
INTO tPresent
FROM TLECTURA
WHERE 
tlectura.des = 'PRESENCIAL';


select COUNT(lecturas.TIPO) 
INTO n_presencial
FROM lecturas, tlectura
WHERE 
tLectura.id = lecturas.tipo
and tlectura.ID = tPresent
and lecturas.FECHALECTURA BETWEEN n_pInicial and n_pFinal;


SELECT tLectura.id
INTO tTelema
FROM TLECTURA
WHERE 
tlectura.des = 'TELEMATICA' OR tlectura.des = 'TELEMTICA';

SELECT COUNT(lecturas.TIPO) 
INTO n_telematica
FROM lecturas, tlectura
WHERE 
tLectura.id = tTelema;



SELECT count(*)
INTO contador_test
FROM
centrales, linea, lineas, contadores, consumos, estados
WHERE
   centrales.ID = 1
and consumos.ANYO BETWEEN '2010' and '2012'
and consumos.MES  BETWEEN 1 and 7
and centrales.ID  = lineas.C1
and contadores.ID = lineas.C2
and contadores.ID = consumos.CONTADOR
and linea.ID      = lineas.LINEA
and estados.ID    = centrales.ESTADO
and estados.ID    = contadores.ESTADO
and estados.ID    = lineas.ESTADO
and estados.ID    = linea.ESTADO;


SELECT COUNT(lecturas.TIPO) 
INTO  n_total
FROM lecturas, tlectura
WHERE 
tLectura.id = lecturas.tipo
--and tlectura.des = 'TELEMATICA' OR tlectura.des = 'TELEMTICA' OR tlectura.des = 'PRESENCIAL';
and tlectura.ID = tPresent OR tlectura.ID = tTelema;

n_pPresencial := n_presencial * 100 / n_total;         

n_pTelematica := n_telematica * 100 / n_total;   



 DBMS_OUTPUT.ENABLE;
 DBMS_OUTPUT.PUT_LINE('');
 DBMS_OUTPUT.PUT_LINE('Consulta para obtener porcentaje de  lecturas de contadores ' || n_total) ;
 DBMS_OUTPUT.PUT_LINE('-----------------------------------------------------');
 DBMS_OUTPUT.PUT_LINE('');
 DBMS_OUTPUT.PUT_LINE('Total lecturas        : ' || n_total);
 DBMS_OUTPUT.PUT_LINE('Lecturas presenciales : ' || n_presencial);
 DBMS_OUTPUT.PUT_LINE('Lecturas telemticas  : ' || n_telematica);
  DBMS_OUTPUT.PUT_LINE('% lecturas telemticas  : ' || n_pPresencial);
  DBMS_OUTPUT.PUT_LINE('%lecturas telemticas   : ' || n_pTelematica);
 
 DBMS_OUTPUT.PUT_LINE('');

IF (n_total = 0)
THEN
RAISE dup_total;
END IF;

--insertamos en la tabla de C6 porcentaje de  lecturas de contadores
 
INSERT INTO C6 (telematica,presencial,pTelematica,pPresencial,total,pInicial,pFinal)
VALUES(tTelema,tPresent,n_pTelematica,n_pPresencial,n_total,n_pInicial_ins,n_pFinal_ins);

-- Fin de las operaciones
 
    rst:='Ok,alta C6 Alta porcentajes lecturas  realizada con exito';
     DBMS_OUTPUT.PUT_LINE('--------------------------------------------------------------------');
     DBMS_OUTPUT.PUT_LINE(rst);
     DBMS_OUTPUT.PUT_LINE('---------------------------------------------------------------------');  
altaLog('Proc. consultaC6', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
' n_total'
|| n_total
||'n_pTelematica: ' 
|| n_pTelematica 
||'n_pPresencial  : '
|| n_pPresencial
|| n_pInicial 
||'n_pInicial  : '
|| 'n_pFinal' 
|| n_pFinal
, 'rst', rst, rst);

COMMIT;

-- controlamos las excepciones
EXCEPTION

WHEN dup_total
THEN

    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('');
    DBMS_OUTPUT.PUT_LINE('n_total : ' || n_total  ); 
    rst := 'ERROR: No hay lecturas';
    DBMS_OUTPUT.PUT_LINE('');  
    DBMS_OUTPUT.PUT_LINE(rst);
    
altaLog('Proc. consultaC6', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
' n_total'
|| n_total
||'n_pTelematica: ' 
|| n_pTelematica 
||'n_pPresencial  : '
|| n_pPresencial
|| n_pInicial 
||'n_pInicial  : '
|| 'n_pFinal' 
|| n_pFinal
, 'rst', rst, rst);

ROLLBACK;


WHEN dup_null
THEN
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('');
    rst := 'ERROR: hay campos no nulos  sin contenido';
    DBMS_OUTPUT.PUT_LINE('');  
    DBMS_OUTPUT.PUT_LINE(rst);
  
altaLog('Proc. consultaC6', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
' n_total'
|| n_total
||'n_pTelematica: ' 
|| n_pTelematica 
||'n_pPresencial  : '
|| n_pPresencial
|| n_pInicial 
||'n_pInicial  : '
|| 'n_pFinal' 
|| n_pFinal
, 'rst', rst, rst);

ROLLBACK;
WHEN OTHERS
THEN
err_msg := SUBSTR (SQLERRM, 1, 100);
rst := 'ERROR:'
|| err_msg;
altaLog('Proc. consultaC6', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
' n_total'
|| n_total
||'n_pTelematica: ' 
|| n_pTelematica 
||'n_pPresencial  : '
|| n_pPresencial
|| n_pInicial 
||'n_pInicial  : '
|| 'n_pFinal' 
|| n_pFinal 
, 'rst', rst, rst);
ROLLBACK;
END consultaC6;
/
CREATE OR REPLACE
PROCEDURE consultaC7(
n_anyos          IN NUMBER,
rst OUT VARCHAR2
)
IS
/******************************************************************************
NOMBRE: consultarContadoresAntiguedad
PROPSITO:  Consulta para obtener el listado todos los contadores de un numero de aos de antiguedad
            la antiguedad considerada por la fecha de fabricacion del modelo
PARAMETERS: n_anyos,rst
INPUT: n_anyos
OUTPUT: n_id, n_contador, n_anyos,rst
RETORNA: 'OK' si la operacin ha tenido exito, 'ERROR: Tipo de Error' en
caso contrario
EJEMPLO DE USO: consultaC7(8, rst);
******************************************************************************/
n_contador                NUMBER;
n_anyo                    NUMBER;
n_anyos_ins               NUMBER;
n_fabrica                 VARCHAR2(4);
contador                  INTEGER;
contadores_test           INTEGER;
err_msg                   VARCHAR2(100);
dup_contadores            EXCEPTION;
dup_des                   EXCEPTION;


CURSOR c1 IS
select contadores.ID, n_anyos,modelos.ANYOFABRICA
from contadores, modelos
where contadores.MODELO = modelos.ID
and   modelos.ANYOFABRICA < (to_char(sysdate,'YYYY')- n_anyos );


BEGIN
contador := 1;
--verificamos que los campos no nulos no sean nulos
IF (n_anyos   IS NULL)
THEN RAISE dup_des;
END IF;

select count(*)
INTO contadores_test 
from contadores, modelos
where contadores.MODELO = modelos.ID
and   modelos.ANYOFABRICA < (to_char(sysdate,'YYYY') - n_anyos );
IF (contadores_test = 0)
THEN
RAISE dup_contadores;
END IF;
 DBMS_OUTPUT.ENABLE(250);
 DBMS_OUTPUT.PUT_LINE('');
 DBMS_OUTPUT.PUT_LINE('CONSULTA DE CONTADORES CON ANTIGEDAD DE ' || n_anyos || ' aos') ;
 DBMS_OUTPUT.PUT_LINE('-------------------------------------------------');
  --abrir el cursor e insertar en la tabla correspondiente
        OPEN c1;
               FETCH c1 INTO n_contador ,n_anyos_ins, n_fabrica ;
               WHILE c1%FOUND  LOOP
                   FETCH c1 INTO n_contador, n_anyos_ins,n_fabrica ;
                      DBMS_OUTPUT.PUT_LINE(' Contador: ' ||n_contador||' Num. aos: ' ||n_anyos_ins ||' Fabricado en:  ' ||n_fabrica);
                      rst :='OK';
                      altaC7(n_contador, n_anyos, n_fabrica,rst);
                  END LOOP;
       CLOSE c1;

-- Fin de las operaciones
 
    rst:='Ok, Alta consultarContadoresAntiguedad   realizada con exito';
       
altaLog('Proc. consultaC7', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
'n_contador: ' 
|| n_contador 
||' n_anyo  : '
|| n_anyo
, 'rst', rst, rst);

COMMIT;

-- controlamos las excepciones
EXCEPTION

WHEN dup_contadores
THEN

    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('');
    DBMS_OUTPUT.PUT_LINE(' n_contador : ' || n_contador  ); 
     rst := 'ERROR: No hay contadores con los aos de antigedad';
    DBMS_OUTPUT.PUT_LINE('');  
    DBMS_OUTPUT.PUT_LINE(rst);
    
altaLog('Proc. consultaC7', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
' n_anyos '
|| n_anyos
, 'rst', rst, rst);

ROLLBACK;

WHEN dup_des
THEN
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('');
    rst := 'ERROR: hay campos no nulos  sin contenido';
    DBMS_OUTPUT.PUT_LINE('');  
    DBMS_OUTPUT.PUT_LINE(rst);
  
altaLog('Proc. consultaC7', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
'n_anyos' 
|| n_anyos
, 'rst', rst, rst);

ROLLBACK;
WHEN OTHERS
THEN
err_msg := SUBSTR (SQLERRM, 1, 100);
rst := 'ERROR:'
|| err_msg;
altaLog('Proc. consultaC7', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
'n_anyos ' || n_anyos 
, 'rst', rst, rst);
ROLLBACK;
END consultaC7;
/* FIN GESTOR_CONSULTAS*/
