CREATE OR REPLACE FUNCTION getCentralEmax(n_id    NUMBER)
RETURN      NUMBER
IS
/******************************************************************************
NOMBRE:     getCentralEmax
PROPSITO:  para conocer la energia mxima que puede producir la central
PARAMETERS: n_id
INPUT:      n_id
OUTPUT:     ret
RETORNA:    ret ( variable con el consumo  )
EJEMPLO DE USO: getCentralEmax (2)
******************************************************************************/
err_msg 	VARCHAR2 (100);
rst 	        VARCHAR2 (100);
ret         NUMBER;
BEGIN
SELECT      centrales.EMAX 
INTO ret
FROM centrales
WHERE
centrales.ID = n_id;
RETURN ret;
EXCEPTION
WHEN OTHERS
THEN
err_msg := SUBSTR (SQLERRM, 1, 100);
rst := 'ERROR:'
|| err_msg;
altaLog('Func. getCentralEmax', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
'n_id:  ' || n_id
, 'rst', rst, rst);
ROLLBACK;
END getCentralEmax;
----------------------------------------------------
/
