CREATE OR REPLACE FUNCTION getConsumoCentral(n_id NUMBER)
RETURN      NUMBER
IS
/******************************************************************************
NOMBRE:     getConsumoCentral
PROPSITO:  para conocer el consumo la central -contadores conectados-, activa
PARAMETERS: n_id
INPUT:      n_id
OUTPUT:     ret
RETORNA:    ret ( variable con el consumo  )
EJEMPLO DE USO: getConsumoCentral (2)
******************************************************************************/
err_msg 	VARCHAR2 (100);
rst 	        VARCHAR2 (100);
ret             NUMBER;
BEGIN
SELECT      sum(consumos.CONSUMO) 
INTO ret
FROM estados, linea, lineas, contadores, centrales, consumos
WHERE
lineas.C1             = centrales.ID    -- conectadas
AND lineas.C2         = contadores.ID   -- con contadores
AND lineas.LINEA      = linea.ID      
AND consumos.CONTADOR = contadores.ID
AND centrales.ESTADO  =   1         -- activas
AND contadores.ESTADO =   1         -- activos
AND lineas.ESTADO     =   1         -- activas
AND Linea.ESTADO      =   1         -- activos
--AND centrales.CLASE   =   1         -- central de distribucion
GROUP BY centrales.ID
HAVING   SUM(consumos.CONSUMO)>-1 AND 
centrales.id = n_id;
RETURN ret;
EXCEPTION
WHEN OTHERS
THEN
err_msg := SUBSTR (SQLERRM, 1, 100);
rst := 'ERROR:'
|| err_msg;
altaLog('Func. getConsumoCentral', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
'n_id:  ' || n_id
, 'rst', rst, rst);
ROLLBACK;
END getConsumoCentral;
----------------------------------
/
