CREATE OR REPLACE FUNCTION getConsumoContador(n_id  NUMBER)
RETURN      NUMBER
IS
/******************************************************************************
NOMBRE:     getConsumoContador
PROPSITO:  para conocer el consumo de un contador, activo y conectado
PARAMETERS: n_id
INPUT:      n_id
OUTPUT: -
RETORNA:    ret ( variable con el consumo total del contador )
EJEMPLO DE USO: getConsumoContador (2)
******************************************************************************/
err_msg 	VARCHAR2 (100);
rst 	        VARCHAR2 (100);
ret         	NUMBER;

BEGIN
SELECT      sum(consumos.CONSUMO) 
INTO ret
FROM estados, linea, lineas, contadores,  consumos
WHERE
lineas.C2              	 = contadores.ID 	-- conectado
AND lineas.LINEA       	 = linea.ID	
AND consumos.CONTADOR  	 = contadores.ID
AND contadores.ESTADO   	=   1		-- en alta
AND lineas.ESTADO       	=   1		-- en alta	
AND Linea.ESTADO        	=   1		-- en alta
GROUP BY consumos.CONTADOR
HAVING   SUM(consumos.CONSUMO)>-1 AND 	        -- con consumo
consumos.CONTADOR = n_id;			
RETURN ret;
EXCEPTION
WHEN OTHERS
THEN
err_msg := SUBSTR (SQLERRM, 1, 100);
rst := 'ERROR:'
|| err_msg;
altaLog('Func. getConsumoContador', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
'n_id:  ' || n_id
, 'rst', rst, rst);
ROLLBACK;
END getConsumoContador;
-------------------------------------------
/