CREATE OR REPLACE
FUNCTION getConsumoContadorFecha(n_id  NUMBER,n_anyo NUMBER,n_mes NUMBER)
RETURN      NUMBER
IS
/******************************************************************************
NOMBRE:     getConsumoContadorFecha
PROPSITO:  para conocer el consumo del contador en un ao y mes determinado
PARAMETERS: n_id, n_anyo, n_mes
INPUT:      n_id, n_ayo, n_mes
OUTPUT:     ret
RETORNA:    ret ( variable con el consumo   )
EJEMPLO DE USO: getConsumoContadorFecha (2,2011,1)
******************************************************************************/
err_msg 	VARCHAR2 (100);
rst 	        VARCHAR2 (100);
ret             NUMBER;

BEGIN
SELECT      sum(consumos.CONSUMO) 
INTO ret
FROM    consumos
WHERE
 consumos.CONTADOR      = n_id
AND consumos.ANYO       = n_anyo
AND consumos.MES        = n_mes;

RETURN ret;
EXCEPTION
WHEN OTHERS
THEN
err_msg := SUBSTR (SQLERRM, 1, 100);
rst := 'ERROR:'
|| err_msg;
altaLog('Func. getConsumoContadorFecha', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
' n_id:  ' || n_id 
||' n_anyo:  ' || n_anyo 
||' n_mes:  ' || n_mes
, 'rst', rst, rst);
END getConsumoContadorFecha;
------------------------------------
/