CREATE OR REPLACE FUNCTION getConsumoLinea(n_id NUMBER)
RETURN      NUMBER
IS
/******************************************************************************
NOMBRE:     getConsumoCentral
PROPSITO:  para conocer el consumo la linea -contadores conectados-, activa
PARAMETERS: n_id
INPUT:      n_id
OUTPUT:     ret
RETORNA:    ret ( variable con el consumo  )
EJEMPLO DE USO: getConsumoLinea (2)
******************************************************************************/
err_msg 	VARCHAR2 (100);
rst 	        VARCHAR2 (100);
ret         NUMBER;
BEGIN
select  sum (consumos.CONSUMO)
INTO ret
from linea, lineas, contadores, consumos, estados
where
linea.ID                  = lineas.LINEA
and lineas.C2             = contadores.ID
and contadores.id         = consumos.CONTADOR
and estados.ID            = contadores.ESTADO
--and contadores.ESTADO     = 1
--and linea.ESTADO          = 1
--and lineas.ESTADO         = 1
group by linea.id
HAVING   SUM(consumos.CONSUMO)>-1 AND 
linea.ID = n_id;
RETURN ret;
EXCEPTION
WHEN OTHERS
THEN
err_msg := SUBSTR (SQLERRM, 1, 100);
rst := 'ERROR:'
|| err_msg;
altaLog('Func. getConsumoLinea', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
'n_id:  ' || n_id
, 'rst', rst, rst);
ROLLBACK;
END getConsumoLinea;
/