CREATE OR REPLACE FUNCTION getConsumoLineaAnyo(
n_id    NUMBER,
n_anyo  NUMBER
)
RETURN      NUMBER
IS
/******************************************************************************
NOMBRE:     getConsumoLineaAnyo
PROPSITO:  para conocer el consumo de una linea en una ao concreto
PARAMETERS: n_id, n_anyo
INPUT:      n_id, n_anyo
OUTPUT:     ret
RETORNA:    ret ( variable con el consumo  )
EJEMPLO DE USO: getConsumoLineaAnyo (2,2011);
******************************************************************************/
ret         NUMBER;
BEGIN
SELECT      sum(consumos.CONSUMO) 
INTO ret
FROM estados, linea, lineas, contadores,  consumos
WHERE
lineas.C2         = contadores.ID -- contadores conectados
AND lineas.LINEA      = linea.ID
AND consumos.CONTADOR = contadores.ID
AND contadores.ESTADO  =   1
AND lineas.ESTADO     =   1
AND Linea.ESTADO      =   1
AND consumos.ANYO     =   n_anyo
GROUP BY linea.ID
HAVING   SUM(consumos.CONSUMO)>-1 AND 
linea.id = n_id ;
IF (ret = 0)
THEN ret :=1;
END IF;
RETURN ret;
END getConsumoLineaAnyo;
---------------------------
/