CREATE OR REPLACE
FUNCTION getConsumoMedioLocalidadFecha(n_id NUMBER, n_anyo NUMBER, n_mes VARCHAR2)
RETURN      NUMBER
IS
/******************************************************************************
NOMBRE:     getConsumoMedioLocalidadFecha
PROPSITO:  para conocer el consumo en un ao determinado de una la central de produccin
PARAMETERS: n_id, n_anyo, n_mes
INPUT:      n_id, n_ayo, n_mes
OUTPUT:     ret
RETORNA:    ret ( variable con el consumo   )
EJEMPLO DE USO: getConsumoMedioLocalidadFecha (2,2011,1)
******************************************************************************/
err_msg 	VARCHAR2 (100);
rst 	        VARCHAR2 (100);
ret             NUMBER(9,2);
consumos_test   INTEGER;
BEGIN

SELECT avg(consumos.CONSUMO)
--SELECT   consumos.id, consumos.anyo, consumos.mes, consumos.CONSUMO, consumos.CONTADOR
INTO ret
FROM CONSUMOS, localidad, contadores, lineas, linea
WHERE
     contadores.ESTADO    =   1             -- vigentes
and linea.ESTADO          =   1             -- activa
and lineas.ESTADO         =   1             -- conexin activa
and linea.ID              = lineas.LINEA
and contadores.ID         = consumos.CONTADOR
and lineas.C2             = consumos.CONTADOR   -- que esten conectados
and localidad.ID           =  n_id    -- de la localidad que buscamos
and consumos.ANYO         = n_anyo    -- anyo de consumo
and consumos.MES          = n_mes     -- mes de consumo
and consumos.consumo >0;              -- con consumo
RETURN ret;
EXCEPTION
WHEN OTHERS
THEN
err_msg := SUBSTR (SQLERRM, 1, 100);
rst := 'ERROR:'
|| err_msg;
altaLog('Func. getConsumoLocalidadFecha', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
' n_id:  ' || n_id 
||' n_anyo:  ' || n_anyo 
||' n_mes:  ' || n_mes
, 'rst', rst, rst);
END getConsumoMedioLocalidadFecha;
-------------------------------------

