CREATE OR REPLACE FUNCTION getIdCliente(n_id NUMBER)
RETURN      NUMBER
IS
/******************************************************************************
NOMBRE:     getIdCliente
PROPSITO:  conocer el codigo del cliente
PARAMETERS: n_id
INPUT:      n_id
OUTPUT:     ret 
RETORNA:    ret ( el codigo del cliente )
EJEMPLO DE USO: getIdCliente (2)
******************************************************************************/
err_msg 	VARCHAR2 (100);
rst 	        VARCHAR2 (100);
ret             NUMBER;

BEGIN

SELECT  clientes.id
INTO ret
FROM  clientes
WHERE
clientes.ID = n_id;
RETURN ret;
EXCEPTION
WHEN OTHERS
THEN
err_msg := SUBSTR (SQLERRM, 1, 100);
rst := 'ERROR:'
|| err_msg;
altaLog('Func. getNomCliente', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
'n_id:  ' || n_id
, 'rst', rst, rst);
ROLLBACK;
END getIdCliente;
----------------------------------------
/