CREATE OR REPLACE FUNCTION getLineaCmax(n_id    NUMBER)
RETURN      NUMBER
IS
/******************************************************************************
NOMBRE:     getLineaCmax
PROPSITO:  para conocer la energia mxima que tiene la linea 
PARAMETERS: n_id
INPUT:      n_id
OUTPUT:     ret
RETORNA:    ret ( variable con la capaciad  )
EJEMPLO DE USO: getLineaCmax (2)
******************************************************************************/
err_msg 	VARCHAR2 (100);
rst 	        VARCHAR2 (100);
ret         NUMBER;
BEGIN
SELECT      linea.CMAX 
INTO ret
FROM linea
WHERE
linea.ID = n_id;
RETURN ret;
EXCEPTION
WHEN OTHERS
THEN
err_msg := SUBSTR (SQLERRM, 1, 100);
rst := 'ERROR:'
|| err_msg;
altaLog('Func. getLineaCmax', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
'n_id:  ' || n_id
, 'rst', rst, rst);
ROLLBACK;
END getLineaCmax;
----------------------------------------------------
/