CREATE OR REPLACE FUNCTION getLineaConsumo(n_id NUMBER)
RETURN      NUMBER
IS
/******************************************************************************
NOMBRE:     getConsumoCentral
PROPSITO:  para conocer el consumo la linea -contadores conectados-, activa
PARAMETERS: n_id
INPUT:      n_id
OUTPUT:     ret
RETORNA:    ret ( variable con el consumo  )
EJEMPLO DE USO: getLineaConsumo (2)
******************************************************************************/
err_msg 	VARCHAR2 (100);
rst 	        VARCHAR2 (100);
ret         NUMBER;
BEGIN
 SELECT  sum (consumos.CONSUMO)
INTO ret
 FROM
 linea, lineas, contadores, consumos
 WHERE
 linea.id = lineas.LINEA
 and contadores.ID = lineas.C2
 and lineas.C2 = consumos.CONTADOR
 and linea.ID = 1
 group by linea.id
 having  sum (consumos.CONSUMO) > 0;

RETURN ret;
EXCEPTION
WHEN OTHERS
THEN
err_msg := SUBSTR (SQLERRM, 1, 100);
rst := 'ERROR:'
|| err_msg;
altaLog('Func. getLineaConsumo', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
'n_id:  ' || n_id
, 'rst', rst, rst);
ROLLBACK;
END getLineaConsumo;
/