CREATE OR REPLACE FUNCTION getNomCliente(n_id NUMBER)
RETURN      VARCHAR2
IS
/******************************************************************************
NOMBRE:     getNomCliente
PROPSITO:  conocer los apellidos y nombre del cliente
PARAMETERS: n_id
INPUT:      n_id
OUTPUT:     ret 
RETORNA:    ret ( contiene los apellidos y nombre  del cliente )
EJEMPLO DE USO: getNomCliente (2)
******************************************************************************/
err_msg 	VARCHAR2 (100);
rst 	        VARCHAR2 (100);
ret             VARCHAR2 (150);

BEGIN

SELECT  (clientes.APE1 ||' ' || clientes.APE2 ||','|| clientes.NOM)
INTO ret
FROM  clientes
WHERE
clientes.ID = n_id;
RETURN ret;
EXCEPTION
WHEN OTHERS
THEN
err_msg := SUBSTR (SQLERRM, 1, 100);
rst := 'ERROR:'
|| err_msg;
altaLog('Func. getNomCliente', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
'n_id:  ' || n_id
, 'rst', rst, rst);
ROLLBACK;
END getNomCliente;
----------------------------------------
/