CREATE OR REPLACE FUNCTION getUbica(n_id IN NUMBER)
RETURN     Varchar2
IS
/******************************************************************************
NOMBRE:     getUbica
PROPSITO:  conocer los datos de la ubicacin
PARAMETERS: n_id
INPUT:      n_id
OUTPUT:     ret
RETORNA:    ret ( contiene los datos de la ubicacin: direccin, num, piso,
                  puerta, localidad, cdigo postal, provincia y pais )
EJEMPLO DE USO: getUbica (2)
******************************************************************************/
err_msg     VARCHAR2 (100);
rst 	    VARCHAR2 (100);
ret         VARCHAR2 (100);
BEGIN
SELECT  
via.DES
|| ubicaciones.DIR ||' '
|| ubicaciones.NUM ||' '
|| ubicaciones.PIS ||' '
|| ubicaciones.PTA ||' '
|| localidad.DES   ||' ('
|| ubicaciones.CODIGOPOSTAL   ||') '
|| provincia.DES   ||' '
|| pais.DES
INTO ret
FROM via, ubicaciones, localidad, provincia, pais
WHERE 
via.ID              =   ubicaciones.VIA
AND localidad.ID    =   ubicaciones.LOCALIDAD
AND provincia.ID    =   localidad.PROVINCIA
AND pais.ID         =   provincia.PAIS
AND ubicaciones.ID  =   n_id;
RETURN ret;
EXCEPTION
WHEN OTHERS
THEN
err_msg := SUBSTR (SQLERRM, 1, 100);
rst := 'ERROR:'
|| err_msg;
altaLog('Func. getUbica', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
'n_id:  ' || n_id
, 'rst', rst, rst);
ROLLBACK;
END getUbica;
--------------------------------------------------------------------
/