create or replace PROCEDURE altaClaseCentral(
n_des IN VARCHAR2,
rst OUT VARCHAR2
)
IS
/******************************************************************************
NOMBRE: altaClaseCentral
PROPSITO: gestiona el alta de un Clase de Central
PARAMETERS: n_des, rst
INPUT: n_des
OUTPUT: rst
RETORNA: 'OK' si la operacin ha tenido sxito, 'ERROR: Tipo de Error' en caso contrario
EJEMPLO DE USO: altaClaseCentral('DISTRIBUCIN', rst);
******************************************************************************/
n_des_ins       		VARCHAR2 (50);
des_test        		INTEGER;
err_msg         		VARCHAR2 (100);
dup_ccentral    		EXCEPTION;
desCCentral_nulo  	EXCEPTION;
BEGIN
n_des_ins := SUBSTR (n_des, 1, 50);
--verificamos si el campo CCENTRAL.des es nulo
IF (n_des_ins IS NULL) THEN
RAISE desCCentral_nulo;
END IF;
--verificamos si existe el tipo de estado
SELECT COUNT (*)
INTO des_test
FROM ccentral
WHERE des = n_des_ins;
IF (des_test > 0)
THEN
RAISE dup_ccentral;
END IF;
-- insertamos el nuevo tipo de ccentral
INSERT INTO ccentral(des) VALUES (n_des_ins);
-- Fin de las operaciones

    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('');
    DBMS_OUTPUT.PUT_LINE('Alta de tipo de CCENTRAL: ' || n_des_ins); 
    rst:='Ok, Alta Tipo CCENTRAL  realizada con exito';
    DBMS_OUTPUT.PUT_LINE('');  
    DBMS_OUTPUT.PUT_LINE(rst); 

--rst := 'OK';
altaLog('Proc. altaClaseCentral', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
'Tipo de CCENTRAL:' || n_des, 'rst', rst, rst);
COMMIT;
EXCEPTION
WHEN dup_ccentral
THEN
    rst := 'ERROR: Ya existe este tipo de  CCENTRAL';
    DBMS_OUTPUT.PUT_LINE('');  
    DBMS_OUTPUT.PUT_LINE(rst); 
altaLog('Proc. altaClaseCentral', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
'Tipo de CCENTRAL: ' || n_des, 'rst', rst, rst);
ROLLBACK;
WHEN desCCentral_nulo
THEN
    rst := 'ERROR: el tipo de CCENTRAL  no debe ser nulo';
    DBMS_OUTPUT.PUT_LINE('');  
    DBMS_OUTPUT.PUT_LINE(rst);
altaLog('Proc. altaClaseCentral', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
'Tipo de CCENTRAL: ' || n_des, 'rst', rst, rst);
ROLLBACK;
WHEN OTHERS
THEN
err_msg := SUBSTR (SQLERRM, 1, 100);
rst := 'ERROR:'
|| err_msg;
altaLog('Proc. altaClaseCentral', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
'Tipo de CCENTRAL: ' || n_des, 'rst', rst, rst);
ROLLBACK;
END altaClaseCentral;
/



drop  SEQUENCE ccentral_SEQ_GRAL;
CREATE  SEQUENCE ccentral_SEQ_GRAL	START WITH 1  INCREMENT BY 1 NOMAXVALUE  NOCACHE;
CREATE OR REPLACE TRIGGER   ccentral_TR_KEY
    BEFORE INSERT       ON  ccentral
    FOR EACH ROW
    BEGIN            SELECT ccentral_SEQ_GRAL.NEXTVAL INTO :NEW.id FROM dual;
END;


declare
    rst varchar2(250);
begin
altaClaseCentral('DISTRIBUCION',rst);
altaClaseCentral('PRODUCCION',rst);
end;