create or replace PROCEDURE altaEstados(
n_des IN VARCHAR2,
rst OUT VARCHAR2
)
IS
/******************************************************************************
NOMBRE: altaEstados
PROPSITO: gestiona el alta de un estado
PARAMETERS: n_des, rst
INPUT: n_des
OUTPUT: rst
RETORNA: 'OK' si la operacin ha tenido scito, 'ERROR: Tipo de Error' en
caso contrario
EJEMPLO DE USO: altaEstado('ALTA', rst)
******************************************************************************/
n_des_ins       VARCHAR2 (50);
des_test        INTEGER;
err_msg         VARCHAR2 (100);
dup_estados      EXCEPTION;
desEstado_nulo      EXCEPTION;
BEGIN
n_des_ins := SUBSTR (n_des, 1, 50);
--verificamos si el campo estados.des es nulo
IF (n_des_ins IS NULL) THEN
RAISE desEstado_nulo;
END IF;
--verificamos si existe el tipo de estado
SELECT COUNT (*)
INTO des_test
FROM ESTADOS
WHERE des = n_des_ins;
IF (des_test > 0)
THEN
RAISE dup_estados;
END IF;
-- insertamos el nuevo tipo de ESTADOS
INSERT INTO ESTADOS(des) VALUES (n_des_ins);
-- Fin de las operaciones

    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('');
    DBMS_OUTPUT.PUT_LINE('Alta de tipo de ESTADOS: ' || n_des_ins); 
    rst:='Ok, Alta Tipo ESTADOS  realizada con exito';
    DBMS_OUTPUT.PUT_LINE('');  
    DBMS_OUTPUT.PUT_LINE(rst); 

--rst := 'OK';
altaLog('Proc. altaESTADOS', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
'Tipo de ESTADOS:' || n_des, 'rst', rst, rst);
COMMIT;
EXCEPTION
WHEN dup_estados
THEN
    rst := 'ERROR: Ya existe este tipo de  ESTADOS';
    DBMS_OUTPUT.PUT_LINE('');  
    DBMS_OUTPUT.PUT_LINE(rst); 
altaLog('Proc. altaESTADOS', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
'Tipo de ESTADOS: ' || n_des, 'rst', rst, rst);
ROLLBACK;
WHEN desEstado_nulo
THEN
    rst := 'ERROR: el tipo de ESTADOS  no debe ser nulo';
    DBMS_OUTPUT.PUT_LINE('');  
    DBMS_OUTPUT.PUT_LINE(rst);
altaLog('Proc. altaESTADOS', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
'Tipo de ESTADOS: ' || n_des, 'rst', rst, rst);
ROLLBACK;
WHEN OTHERS
THEN
err_msg := SUBSTR (SQLERRM, 1, 100);
rst := 'ERROR:'
|| err_msg;
altaLog('Proc. altaESTADOS', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
'Tipo de ESTADOS: ' || n_des, 'rst', rst, rst);
ROLLBACK;
END altaEstados;
/
declare
    rst varchar2(250);
begin
--- ESTADOS
------------ 
altaEstados('ALTA', rst);
altaEstados('BAJA', rst);
altaEstados('MODIFICACION', rst);
end;


