create or replace PROCEDURE altaTipoCliente(
n_des IN VARCHAR2,
rst OUT VARCHAR2
)
IS
/******************************************************************************
NOMBRE: altaTipoCliente
PROPSITO: gestiona el alta de un tipo decliente
PARAMETERS: n_des, rst
INPUT: n_des
OUTPUT: rst
RETORNA: 'OK' si la operacin ha sido exitosa, 'ERROR: Tipo de Error' en
caso contrario
EJEMPLO DE USO: altaTipoCliente('PARTICULAR', rst);
******************************************************************************/
n_des_ins       VARCHAR2 (50);
des_test        INTEGER;
err_msg         VARCHAR2 (100);
dup_des      EXCEPTION;
des_nulo      EXCEPTION;
BEGIN
n_des_ins := SUBSTR (n_des, 1, 50);
--verificamos si el campo tCliente.des es nulo
IF (n_des_ins IS NULL) THEN
RAISE des_nulo;
END IF;
--verificamos si existe el tipo de Cliente
SELECT COUNT (*)
INTO des_test
FROM tCliente
WHERE des = n_des_ins;
IF (des_test > 0)
THEN
RAISE dup_des;
END IF;
-- insertamos el nuevo tipo de Cliente
INSERT INTO tCliente(des) VALUES (n_des_ins);
-- Fin de las operaciones

    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('');
    DBMS_OUTPUT.PUT_LINE('Alta de tipo de Cliente: ' || n_des_ins); 
    rst:='Ok, Alta Tipo Cliente  realizada con exito';
    DBMS_OUTPUT.PUT_LINE('');  
    DBMS_OUTPUT.PUT_LINE(rst); 

--rst := 'OK';
altaLog('Proc. altaTipoCliente', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
'Tipo de Cliente:' || n_des, 'rst', rst, rst);
COMMIT;
EXCEPTION
WHEN dup_des
THEN
    rst := 'ERROR: Ya existe este tipo de  Cliente';
    DBMS_OUTPUT.PUT_LINE('');  
    DBMS_OUTPUT.PUT_LINE(rst); 
altaLog('Proc. altaTipoCliente', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
'Tipo de Cliente: ' || n_des, 'rst', rst, rst);
ROLLBACK;
WHEN des_nulo
THEN
    rst := 'ERROR: el tipo de Cliente  no debe ser nulo';
    DBMS_OUTPUT.PUT_LINE('');  
    DBMS_OUTPUT.PUT_LINE(rst);
altaLog('Proc. altaTipoCliente', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
'Tipo de Cliente: ' || n_des, 'rst', rst, rst);
ROLLBACK;
WHEN OTHERS
THEN
err_msg := SUBSTR (SQLERRM, 1, 100);
rst := 'ERROR:'
|| err_msg;
altaLog('Proc. altaTipoCliente', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
'Tipo de Cliente: ' || n_des, 'rst', rst, rst);
ROLLBACK;
END altaTipoCliente;
/

INSERT INTO tCliente(des) VALUES ('FUNCIONARIO');
-- prueba de uso

DECLARE rst VARCHAR2(250);
BEGIN
altaTipoCliente('PARTICULAR', rst);
altaTipoCliente('EMPRESA', rst);
END;

