create or replace PROCEDURE altaVia (
n_des IN VARCHAR2,
rst OUT VARCHAR2
)
IS
/******************************************************************************
NOMBRE: altaVia
PROPSITO: gestiona el alta de una via
PARAMETERS: n_des, rst
INPUT: n_des
OUTPUT: rst
RETORNA: 'OK' si la operacin ha sido exitosa, 'ERROR: Tipo de Error' en
caso contrario
EJEMPLO DE USO: altaVia('Rambla', rst);
******************************************************************************/
n_des_ins       VARCHAR2 (50);
des_test        INTEGER;
err_msg         VARCHAR2 (100);
dup_desVia      EXCEPTION;
desVia_nulo      EXCEPTION;
BEGIN
n_des_ins := SUBSTR (n_des, 1, 50);
--verificamos si el campo Via.des es nulo
IF (n_des_ins IS NULL) THEN
RAISE desVia_nulo;
END IF;
--verificamos si existe el tipo de via
SELECT COUNT (*)
INTO des_test
FROM VIA
WHERE des = n_des_ins;
IF (des_test > 0)
THEN
RAISE dup_desVia;
END IF;
-- insertamos el nuevo tipo de via
INSERT INTO VIA(des) VALUES (n_des_ins);
-- Fin de las operaciones

    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('');
    DBMS_OUTPUT.PUT_LINE('Alta de tipo de via: ' || n_des_ins); 
    rst:='Ok, Alta Tipo Via  realizada con exito';
    DBMS_OUTPUT.PUT_LINE('');  
    DBMS_OUTPUT.PUT_LINE(rst); 

--rst := 'OK';
altaLog('Proc. altaVia', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
'Tipo de Via:' || n_des, 'rst', rst, rst);
COMMIT;
EXCEPTION
WHEN dup_desVia
THEN
    rst := 'ERROR: Ya existe este tipo de  Via';
    DBMS_OUTPUT.PUT_LINE('');  
    DBMS_OUTPUT.PUT_LINE(rst); 
altaLog('Proc. altaVia', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
'Tipo de Via: ' || n_des, 'rst', rst, rst);
ROLLBACK;
WHEN desVia_nulo
THEN
    rst := 'ERROR: el tipo de via  no debe ser nulo';
    DBMS_OUTPUT.PUT_LINE('');  
    DBMS_OUTPUT.PUT_LINE(rst);
altaLog('Proc. altaVia', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
'Tipo de Via: ' || n_des, 'rst', rst, rst);
ROLLBACK;
WHEN OTHERS
THEN
err_msg := SUBSTR (SQLERRM, 1, 100);
rst := 'ERROR:'
|| err_msg;
altaLog('Proc. altaVia', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
'Tipo de Via: ' || n_des, 'rst', rst, rst);
ROLLBACK;
END altaVia;
/

declare
    rst varchar2(250);
begin
altaVia('Avd.',rst);
altaVia('C/',rst);
altaVia('Pje.',rst);
altaVia('Plaza',rst);
altaVia('Pol.Ind.',rst);
altaVia('Ctra.',rst);
altaVia('Paseo',rst);
altaVia('Camino',rst);
altaVia('Travesia',rst);
altaVia('Rbla.',rst);
altaVia('-------',rst);
altaVia('Glorieta',rst);
altaVia('Partida',rst);
altaVia('Rotonda',rst);
altaVia('Grupo',rst);
altaVia('Boulevar',rst);
altaVia('Rue',rst);
altaVia('Street',rst);
altaVia('Avenue',rst);
altaVia('Places',rst);
altaVia('Ronda',rst);
altaVia('Va',rst);
end;

