CREATE OR REPLACE
PROCEDURE altaC1(
n_contrato            IN NUMBER,
n_pContratada         IN NUMBER,
n_tpConsumo           IN NUMBER,
n_mConsumo            IN NUMBER,
n_anyo                IN NUMBER,
n_mes                 IN NUMBER,
rst OUT VARCHAR2
)
IS
/******************************************************************************
NOMBRE: altaC1 
PROPSITO: Alta registro en la tabla C1
PARAMETERS: n_contrato, n_pContratada , n_tpConsumo, n_mConsumo, n_anyo, n_mes,rst
INPUT:      n_contrato, n_pContratada , n_tpConsumo, n_mConsumo, n_anyo, n_mes
OUTPUT: ,rst
RETORNA: 'OK' si la operacin ha tenido exito, 'ERROR: Tipo de Error' en caso contrario
EJEMPLO DE USO: altaC1(1,12,12.30,12,2011,7, rst);
******************************************************************************/
contrato_test           INTEGER;
err_msg                 VARCHAR2(100);
dup_contrato            EXCEPTION;
dup_null                EXCEPTION;

BEGIN

--verificamos que los campos no nulos no sean nulos
IF (n_contrato        IS NULL)
OR (n_pContratada     IS NULL)
OR (n_tpConsumo       IS NULL)
OR (n_mConsumo        IS NULL)
OR (n_anyo            IS NULL)
OR (n_mes             IS NULL)
THEN RAISE dup_null;
END IF;
-- comprobar contrato
SELECT COUNT(*)
INTO contrato_test
FROM contratos
WHERE
contratos.id = n_contrato;
IF      (contrato_test = 0)
   THEN RAISE dup_contrato;
END IF;
--insertamos en la tabla de C1 contadoresCiudadFecha
INSERT INTO C1 ( contrato, pContratada, tpConsumo, mConsumo, anyo, mes )
VALUES ( n_contrato, n_pContratada, n_tpConsumo, n_mConsumo, n_anyo, n_mes); 
-- Fin de las operaciones
      rst:='Ok, C1 con exito';
      DBMS_OUTPUT.PUT_LINE('');
      DBMS_OUTPUT.PUT_LINE(rst);
       DBMS_OUTPUT.PUT_LINE(
  'n_contrato: '
 || n_contrato
 || ' n_pContratada: '
 || n_pContratada
 || ' n_tpConsumo: '
 ||n_tpConsumo 
 || ' n_mConsumo: '
 ||  n_mConsumo
 || ' n_anyo: ' 
 || n_anyo
 );
    
altaLog('Proc. altaC1', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
 'n_contrato: '
 || n_contrato
 || ' n_pContratada: '
 || n_pContratada
 || ' n_tpConsumo: '
 ||n_tpConsumo 
 || ' n_mConsumo: '
 ||  n_mConsumo
 || ' n_anyo: ' 
 || n_anyo
  || ' n_mes: ' 
 || n_mes
, 'rst', rst, rst);

COMMIT;
-- controlamos las excepciones
EXCEPTION

WHEN dup_contrato
THEN
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('');
    DBMS_OUTPUT.PUT_LINE(
 'n_contrato: '
 || n_contrato
 || ' n_pContratada: '
 || n_pContratada
 || ' n_tpConsumo: '
 ||n_tpConsumo 
 || ' n_mConsumo: '
 ||  n_mConsumo
 || ' n_anyo: ' 
 || n_anyo
  || ' n_mes: ' 
 || n_mes
  ); 
     rst := 'ERROR: No existe el contrato';
    DBMS_OUTPUT.PUT_LINE('');  
    DBMS_OUTPUT.PUT_LINE(rst);
    
altaLog('Proc. altaC1', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
 'n_contrato: '
 || n_contrato
 || ' n_pContratada: '
 || n_pContratada
 || ' n_tpConsumo: '
 ||n_tpConsumo 
 || ' n_mConsumo: '
 ||  n_mConsumo
 || ' n_anyo: ' 
 || n_anyo
  || ' n_mes: ' 
 || n_mes

, 'rst', rst, rst);
ROLLBACK;
WHEN dup_null
THEN
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('');
    rst := 'ERROR: hay campos no nulos  sin contenido';
    DBMS_OUTPUT.PUT_LINE('');  
    DBMS_OUTPUT.PUT_LINE(rst);
altaLog('Proc. altaC1', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
 'n_contrato: '
 || n_contrato
 || ' n_pContratada: '
 || n_pContratada
 || ' n_tpConsumo: '
 ||n_tpConsumo 
 || ' n_mConsumo: '
 ||  n_mConsumo
 || ' n_anyo: ' 
 || n_anyo
  || ' n_mes: ' 
 || n_mes

, 'rst', rst, rst);
ROLLBACK;
WHEN OTHERS
THEN
err_msg := SUBSTR (SQLERRM, 1, 100);
rst := 'ERROR:'
|| err_msg;
altaLog('Proc. altaC1', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
 'n_contrato: '
 || n_contrato
 || ' n_pContratada: '
 || n_pContratada
 || ' n_tpConsumo: '
 ||n_tpConsumo 
 || ' n_mConsumo: '
 ||  n_mConsumo
 || ' n_anyo: ' 
 || n_anyo
  || ' n_mes: ' 
 || n_mes
, 'rst', rst, rst);
ROLLBACK;
END altaC1;
/
/*
--prueba de uso
declare rst varchar2(250);
begin
--n_contrato, n_pContratada , n_tpConsumo, n_mConsumo, n_anyo, n_mes
altaC1(1,12,12.30,12,2011,7, rst);
end;
*/