CREATE OR REPLACE
PROCEDURE altaC2(
n_central		IN NUMBER,
n_ubica    	IN NUMBER,
n_eEmitida		IN NUMBER,
n_eMax 		IN NUMBER,
rst OUT VARCHAR2
)
IS
/******************************************************************************
NOMBRE:  altaC2 
PROPSITO:  consultarCentralesDistribucionMasEnergia
PARAMETERS: n_central,n_ubica,n_eEmitida,n_eMax ,rst
INPUT:  n_central,n_ubica,n_eEmitida,n_eMax 
RETORNA: 'OK' si la operacin ha tenido exito, 'ERROR: Tipo de Error' en caso contrario
EJEMPLO DE USO: altaC2(1,10,10,30, rst);
******************************************************************************/

err_msg             VARCHAR2(100);

central_test	INTEGER;
ubica_test		INTEGER;
dup_central       EXCEPTION;
dup_ubica		EXCEPTION;
dup_null        EXCEPTION;
            
BEGIN


--verificamos que los campos no nulos no sean nulos
IF (n_central		IS NULL)
OR (n_ubica		IS NULL)
OR (n_eEmitida		IS NULL)
OR (n_eMax 		IS NULL)

THEN RAISE dup_null;
END IF;

-- verificar central y ubicacin 

SELECT count(*)
INTO central_test
FROM centrales
WHERE 
centrales.id = n_central;
IF (central_test = 0)
THEN
RAISE dup_central;
END IF;

SELECT count(*)
INTO ubica_test
FROM ubicaciones
WHERE 
ubicaciones.id = n_ubica;
IF (ubica_test = 0)
THEN
RAISE dup_ubica;
END IF;


 DBMS_OUTPUT.ENABLE;
 DBMS_OUTPUT.PUT_LINE('');
 DBMS_OUTPUT.PUT_LINE('consultarCentralesDistribucionMasEnergia' 
||' n_central:'
||n_central
||' n_ubica'
|| n_central
|| ' n_eEmitida:'
|| n_eEmitida
|| ' n_eMax :'
|| n_eMax 
) ;
 DBMS_OUTPUT.PUT_LINE('-----------------------------------------------------');
 DBMS_OUTPUT.PUT_LINE('');
  

--insertamos en la tabla de C3 
 
INSERT INTO C2 (central,ubica,eEmitida,eMax)  
VALUES(n_central,n_ubica,n_eEmitida,n_eMax );

-- Fin de las operaciones
 
    rst:='Ok, AltaconsultarCentralesDistribucionMasEnergia';
       
altaLog('Proc. altaC2', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
' n_central:'
||n_central
||' n_ubica'
|| n_central
|| ' n_eEmitida:'
|| n_eEmitida
|| ' n_eMax :'
|| n_eMax 
, 'rst', rst, rst);

COMMIT;

-- controlamos las excepciones
EXCEPTION

WHEN dup_central
THEN

    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('');
    DBMS_OUTPUT.PUT_LINE('consultarClientesContadoresAltaDisponibiliad' 
||' n_central:'
||n_central
||' n_ubica'
|| n_central
|| ' n_eEmitida:'
|| n_eEmitida
|| ' n_eMax :'
|| n_eMax 
) ;
    rst := 'ERROR: No hay central';
    DBMS_OUTPUT.PUT_LINE('');  
    DBMS_OUTPUT.PUT_LINE(rst);
    
altaLog('Proc. altaC2', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
' n_central:'
||n_central
||' n_ubica'
|| n_central
|| ' n_eEmitida:'
|| n_eEmitida
|| ' n_eMax :'
|| n_eMax 
, 'rst', rst, rst);

ROLLBACK;


WHEN dup_null
THEN
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('');
    rst := 'ERROR: hay campos no nulos  sin contenido';
    DBMS_OUTPUT.PUT_LINE('');  
    DBMS_OUTPUT.PUT_LINE(rst);
  
altaLog('Proc. altaC2', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
' n_central:'
||n_central
||' n_ubica'
|| n_central
|| ' n_eEmitida:'
|| n_eEmitida
|| ' n_eMax :'
|| n_eMax 
, 'rst', rst, rst);

ROLLBACK;

WHEN dup_ubica
THEN
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('');
    rst := 'ERROR: No hay ubicacion';
    DBMS_OUTPUT.PUT_LINE('');  
    DBMS_OUTPUT.PUT_LINE(rst);
  
altaLog('Proc. altaC2', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
' n_central:'
||n_central
||' n_ubica'
|| n_central
|| ' n_eEmitida:'
|| n_eEmitida
|| ' n_eMax :'
|| n_eMax 
, 'rst', rst, rst);

ROLLBACK;


ROLLBACK;
WHEN OTHERS
THEN
err_msg := SUBSTR (SQLERRM, 1, 100);
rst := 'ERROR:'
|| err_msg;
altaLog('Proc. altaC2', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
' n_central:'
||n_central
||' n_ubica'
|| n_central
|| ' n_eEmitida:'
|| n_eEmitida
|| ' n_eMax :'
|| n_eMax 
, 'rst', rst, rst);
ROLLBACK;
END altaC2;
/
/*
--PRUEBA DE USO
declare rst varchar2(250);
begin
altaC2(1,10,10,30, rst);
end;
*/
