CREATE OR REPLACE
PROCEDURE altaC5(
n_id         	IN NUMBER,
n_contador		IN NUMBER,
n_consumo		IN NUMBER,
n_eProd		IN NUMBER,
n_ini		  	IN VARCHAR2,
n_fin		  	IN VARCHAR2,
rst OUT VARCHAR2
)
IS
/******************************************************************************
NOMBRE:  altaC5 
PROPSITO:  Alta en la tabla C5
PARAMETERS: n_id, n_contador, n_consumo, n_eProd, n_ini, n_fin ,rst
INPUT:    n_id, n_contador, n_consumo, n_eProd, n_ini, n_fin 
OUTPUT:     rst
RETORNA:    'OK' si la operacin ha tenido exito, 'ERROR: Tipo de Error' en caso contrario
EJEMPLO DE USO: altaC5(1,2,30,40,'01/01/2012','01/06/2012', rst);
******************************************************************************/
n_ini_ins   VARCHAR2(11);
n_fin_ins   VARCHAR2(11);

err_msg             VARCHAR2(100);
dup_null            EXCEPTION;
            
BEGIN

--comprobamos la longitud de las cadenas
n_ini_ins   := SUBSTR (n_ini, 1, 11);
n_fin_ins   := SUBSTR (n_fin, 1, 11);


--verificamos que los campos no nulos no sean nulos
IF (n_id IS NULL)
OR ( n_contador  IS NULL)
OR  (n_consumo  IS NULL)
OR  (n_eProd  IS NULL)
OR ( n_ini_ins IS NULL)
OR  (n_fin_ins  IS NULL)
THEN RAISE dup_null;
END IF;

  
--insertamos en la tabla de C5 
 
INSERT INTO C5 (central, contador, consumo, eProd, pInicial ,pFinal)
VALUES(n_id, n_contador,n_consumo,n_eProd ,n_ini_ins,n_fin_ins);

-- Fin de las operaciones
 
    rst:='OK, Alta C5';
    DBMS_OUTPUT.PUT_LINE('');  
    DBMS_OUTPUT.PUT_LINE(rst);
       
altaLog('Proc. altaC5', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
' n_id'
|| n_id
||'  n_contador: '
|| n_contador
||'  n_consumo  : '
|| n_consumo
, 'rst', rst, rst);

COMMIT;

-- controlamos las excepciones
EXCEPTION


WHEN dup_null
THEN
    DBMS_OUTPUT.PUT_LINE('');
    rst := 'ERROR: hay campos no nulos  sin contenido';
    DBMS_OUTPUT.PUT_LINE('');  
    DBMS_OUTPUT.PUT_LINE(rst);
  
altaLog('Proc. altaC5', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
' n_id'
|| n_id
||'  n_contador: ' 
|| n_contador 
||'  n_consumo  : '
|| n_consumo
, 'rst', rst, rst);

ROLLBACK;
WHEN OTHERS
THEN
err_msg := SUBSTR (SQLERRM, 1, 100);
rst := 'ERROR:'
|| err_msg;
altaLog('Proc. altaC5', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
' n_id'
|| n_id
||'  n_contador: ' 
|| n_contador 
||'  n_consumo  : '
|| n_consumo
, 'rst', rst, rst);
ROLLBACK;
END altaC5;
/
/*
declare rst varchar2(250);
begin
--Consulta consumo contadores de central y energia producida por esta
--n_id, n_contador, n_consumo, n_eProd, n_ini, n_fin ,rst
altaC5(1,2,30,40,'01/01/2012','01/06/2012', rst);
end;
*/
