CREATE OR REPLACE
PROCEDURE altaC7(
n_contador	   IN NUMBER,
n_anyo             IN NUMBER,
n_fabrica          IN VARCHAR2,
rst OUT VARCHAR2
)
IS
/******************************************************************************
NOMBRE:  altaC7 
PROPSITO:  alta en la tabla de consultas C7: contadores, aos de antiguedad 
PARAMETERS: n_contador, n_anyo, n_fabrica , sysdate,rst
INPUT:  n_contador, n_anyo, n_fabrica
RETORNA: 'OK' si la operacin ha tenido xito, 'ERROR: Tipo de Error' en caso contrario
EJEMPLO DE USO: altaC7(2,7,'1997', rst);
******************************************************************************/
err_msg       VARCHAR2(100);
contador_test INTEGER;
dup_contador  EXCEPTION;
dup_null            EXCEPTION;
 
 
            
BEGIN

--verificamos que los campos no nulos no sean nulos
IF (n_contador   IS NULL)
OR (n_anyo   IS NULL)
THEN RAISE dup_null;
END IF;

-- verificar que existe el contador
SELECT count(*)
INTO contador_test
FROM contadores
WHERE 
contadores.id = n_contador;
IF (contador_test = 0)
THEN
RAISE dup_contador;
END IF;

--insertamos en la tabla de C7 
 
INSERT INTO C7 (contador, anyos,fabrica, fechaConsulta)
VALUES(n_contador, n_anyo, n_fabrica,to_char(sysdate,'DD/MM/YYYY'));


-- Fin de las operaciones
 
    rst:='Ok, alta C7 Alta consultarContadoresAntiguedad';
    DBMS_OUTPUT.PUT_LINE('--------------------------------------------');
    DBMS_OUTPUT.PUT_LINE(rst);  
    DBMS_OUTPUT.PUT_LINE('---------------------------------------------');

       
altaLog('Proc. altaC7', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
' n_contador:'
||n_contador
||' n_anyo'
|| n_anyo
|| ' n_fabrica'
|| n_fabrica
, 'rst', rst, rst);

COMMIT;

-- controlamos las excepciones
EXCEPTION

WHEN dup_contador
THEN

    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('');
    DBMS_OUTPUT.PUT_LINE('ERROR: No existe el contador' 
||' n_contador:'
||n_contador
||' n_anyo'
|| n_anyo
|| ' n_fabrica'
|| n_fabrica
) ;
    rst := 'ERROR: No existe el contador';
    DBMS_OUTPUT.PUT_LINE('');  
    DBMS_OUTPUT.PUT_LINE(rst);
    
altaLog('Proc. altaC7', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
' n_contador:'
||n_contador
||' n_anyo'
|| n_anyo
|| ' n_fabrica'
|| n_fabrica
, 'rst', rst, rst);

ROLLBACK;
WHEN dup_null
THEN
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('');
    rst := 'ERROR: hay campos no nulos  sin contenido';
    DBMS_OUTPUT.PUT_LINE('');  
    DBMS_OUTPUT.PUT_LINE(rst);
  
altaLog('Proc. altaC7', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
' n_contador:'
||n_contador
||' n_anyo'
|| n_anyo
|| ' n_fabrica'
|| n_fabrica
, 'rst', rst, rst);

ROLLBACK;

WHEN OTHERS
THEN
err_msg := SUBSTR (SQLERRM, 1, 100);
rst := 'ERROR:'
|| err_msg;
altaLog('Proc. altaC7', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
' n_contador:'
||n_contador
||' n_anyo'
|| n_anyo
|| 'n_fabrica'
|| n_fabrica
, 'rst', rst, rst);
ROLLBACK;
END altaC7;
/
