CREATE OR REPLACE
PROCEDURE consultaC1(
n_localidad_des   IN VARCHAR2,
n_anyo        IN NUMBER,
n_mes         IN NUMBER,
rst OUT VARCHAR2
)
IS
/******************************************************************************
NOMBRE: consultaC1 
PROPSITO: Dada una ciudad y una fecha , los contadores donde el consumo mensual en la fecha 
supere  el 80% del consumo medio de todos los contadores de la ciudad en ese periodoDonada una ciutat i una data com a parmetres, el llistat de

       Codi de contracte.
       La potncia mxima contractada.
       El tant per cent de consum elctric consumit en relaci al consum mitj.
        Tot aix ordenat de forma ascendent pel tant per cent de consum elctric consumit.
PARAMETERS: n_anyos,rst
INPUT: n_localidad_des, anyo, n_mes
OUTPUT: n_localidad_des, anyo, n_mes ,rst
RETORNA: 'OK' si la operacin ha tenido exito, 'ERROR: Tipo de Error' en caso contrario
EJEMPLO DE USO: consultaC1('TERRASSA',2011,7, rst);
******************************************************************************/

localidad_test    INTEGER;
n_contrato        NUMERIC;
n_potencia        NUMERIC;
n_contador        NUMERIC;
n_consumo         NUMERIC; 
n_tpConsumo       NUMERIC(9,2);
n_mConsumo        NUMERIC(9,2);
n_localidad_des_ins VARCHAR2(50);
err_msg           VARCHAR2(100);
dup_localidad    EXCEPTION;
dup_null         EXCEPTION;

CURSOR C1 IS
select distinct contratos.ID , contratos.PCONTRATO , contratos.CONTADOR, sum(consumos.consumo) --(distinct contadores.ID)
from contadores, consumos, lineas, linea, contratos, localidad
WHERE 
contadores.ESTADO  = 1 -- activos
and localidad.ID =  localidad_test             -- de la localidad
and linea.id = lineas.LINEA
and lineas.C2 = consumos.CONTADOR               -- que esten conectados y tengan consumo
and contratos.CONTADOR = consumos.CONTADOR      --con contrato
and consumos.ANYO = n_anyo
and consumos.MES =  n_mes
group by contratos.ID,contratos.PCONTRATO,contratos.CONTADOR,(consumos.consumo)
having sum(consumos.CONTADOR) > 0
order by sum(consumos.consumo) asc; --en forma ascendent

-----------------------------------------

BEGIN
n_localidad_des_ins :=  SUBSTR (n_localidad_des, 1, 50);
--verificamos que los campos no nulos no sean nulos
    IF  (n_localidad_des  IS NULL)
    OR  (n_anyo        IS NULL)
    OR  (n_mes         IS NULL)
THEN RAISE dup_null;
END IF;


--obtener el cdigo de la localidad

SELECT localidad.ID
INTO localidad_test
FROM localidad
WHERE
localidad.DES = n_localidad_des;
IF      (localidad_test = 0)
   THEN RAISE dup_localidad;
END IF;
  
 OPEN c1;
               FETCH C1  INTO n_contrato, n_potencia, n_contador, n_consumo ;

                WHILE (c1%FOUND) --and (getConsumoContadorFecha(n_contador,n_anyo,n_mes) > 0.8*getConsumoMedioLocalidadFecha(n_localidad,n_anyo,n_mes)))
                 LOOP                  
                      FETCH C1   INTO n_contrato, n_potencia, n_contador, n_consumo ;

--actualizo variables con las operaciones
 n_tpConsumo  := 100*getConsumoContadorFecha(n_contador,n_anyo,n_mes)/getConsumoMedioLocalidadFecha(localidad_test,n_anyo,n_mes);
 n_mConsumo   := getConsumoContadorFecha(n_contador,n_anyo,n_mes);
 
--n_contrato, n_pContratada , n_tpConsumo, n_mConsumo, n_anyo, n_mes
 altaC1(n_contrato, n_potencia, n_tpConsumo,n_mConsumo,n_anyo, n_mes,rst);
 
  DBMS_OUTPUT.ENABLE(250);
  DBMS_OUTPUT.PUT_LINE('-----------------------------------------------------');
  DBMS_OUTPUT.PUT_LINE(
 ' Codigo contrato: '
 ||n_contrato
 || ' Potencia contratada: '
 || n_potencia
 || ' % consumo respecto consumo medio : '
 || n_tpConsumo
 ||' Consumo contador: '
 ||n_mConsumo
 || ' Anyo: '
 || n_anyo
 || ' Mes: '
 || n_mes);
               END LOOP;
          CLOSE c1;
--end cursorLocalidad;
-- Fin de las operaciones
    rst:='Ok, Alta C1   realizada con exito';
 altaLog('Proc. altaC1', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
'n_contador: ' 
|| n_contador 
||'n_anyo  : '
|| n_anyo
, 'rst', rst, rst);

COMMIT;
-- controlamos las excepciones
EXCEPTION
WHEN dup_localidad
THEN
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('');
    rst := 'ERROR: NO existe la localidad';
    DBMS_OUTPUT.PUT_LINE('');  
    DBMS_OUTPUT.PUT_LINE(rst);
altaLog('Proc. altaC1', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
'n_localidad' 
|| localidad_test
|| 'n_fecha'
|| n_anyo
, 'rst', rst, rst);
ROLLBACK;

WHEN dup_null
THEN
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('');
    rst := 'ERROR: hay campos no nulos  sin contenido';
    DBMS_OUTPUT.PUT_LINE('');  
    DBMS_OUTPUT.PUT_LINE(rst);
altaLog('Proc. altaC1', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
'n_localidad' 
|| localidad_test
|| 'n_fecha'
|| n_anyo
, 'rst', rst, rst);
ROLLBACK;

WHEN OTHERS
THEN
err_msg := SUBSTR (SQLERRM, 1, 100);
rst := 'ERROR:'
|| err_msg;
altaLog('Proc. altaC1', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
'n_anyos ' || n_anyo 
, 'rst', rst, rst);
ROLLBACK;
END consultaC1;
/

--prueba de uso
declare rst varchar2(250);
begin
consultaC1('TERRASSA',2011,7, rst);
end;

select * from log


