CREATE OR REPLACE
PROCEDURE consultaC3(
n_top       IN INTEGER,
rst OUT VARCHAR2
)
IS
/******************************************************************************
NOMBRE:  consultaC3 
PROPSITO:  Consulta de las 10 lineas ms cargadas en relacin a su capacidad mxima
PARAMETERS: n_linea,n_cLinea,n_eAmplia,rst
INPUT:  n_linea,n_cLinea,n_eAmplia
RETORNA: 'OK' si la operacin ha tenido exito, 'ERROR: Tipo de Error' en caso contrario
EJEMPLO DE USO: consultaC3(10, rst);
******************************************************************************/

err_msg           VARCHAR2(100);
linea_test	  INTEGER;
n_id              NUMBER;
n_consumo         NUMBER(9,2);
n_amplia          NUMBER(9,2);
dup_null          EXCEPTION;
  

CURSOR c1 IS
Select linea.id, 100*getLineaConsumo(linea.id)/getLineaCmax(linea.id), getLineaCmax(linea.id)-getLineaConsumo(linea.id)
from linea
group by linea.id, linea.CMAX
order by linea.CMAX;

BEGIN

-- abrimos el cursor para actualizar los resultados
OPEN c1;
               FETCH c1 INTO n_id, n_consumo, n_amplia ;
               WHILE (c1%FOUND and ( c1%ROWCOUNT <= n_top)) LOOP  
                   FETCH c1 INTO n_id, n_consumo, n_amplia ;
                      DBMS_OUTPUT.PUT_LINE(' linea: ' || n_id ||' porcentaje ocupacin  : '|| n_consumo ||' puede ampliar:  '  || n_amplia ||' KW' );
                      rst :='OK, alta C3';
                      altaC3(n_id, n_consumo, n_amplia,rst);
                  END LOOP;
       CLOSE c1;

-- Fin de las operaciones
 
    rst:='OK';
       
altaLog('Proc. consultaC3', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
' n_id:'
||n_id
||' tanto por ciento '
|| n_consumo
|| ' n_amplia'
|| n_amplia
, 'rst', rst, rst);

COMMIT;

-- controlamos las excepciones
EXCEPTION


WHEN OTHERS
THEN
err_msg := SUBSTR (SQLERRM, 1, 100);
rst := 'ERROR:'
|| err_msg;
altaLog('Proc. consultaC3', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
' n_id:'
||n_id
||' tanto por ciento '
|| n_consumo
|| ' n_amplia'
|| n_amplia

, 'rst', rst, rst);
ROLLBACK;
END consultaC3;
/
--PRUEBA DE USO C3
declare rst varchar2(250);
begin
consultaC3(10, rst);
end;
/