CREATE OR REPLACE
PROCEDURE consultaC7(
n_anyos          IN NUMBER,
rst OUT VARCHAR2
)
IS
/******************************************************************************
NOMBRE: consultarContadoresAntiguedad
PROPSITO:  Consulta para obtener el listado todos los contadores de un numero de aos de antiguedad
            la antiguedad considerada por la fecha de fabricacion del modelo
PARAMETERS: n_anyos,rst
INPUT: n_anyos
OUTPUT: n_id, n_contador, n_anyos,rst
RETORNA: 'OK' si la operacin ha tenido exito, 'ERROR: Tipo de Error' en
caso contrario
EJEMPLO DE USO: consultaC7(8, rst);
******************************************************************************/
n_contador                NUMBER;
n_anyo                    NUMBER;
n_anyos_ins               NUMBER;
n_fabrica                 VARCHAR2(4);
contador                  INTEGER;
contadores_test           INTEGER;
err_msg                   VARCHAR2(100);
dup_contadores            EXCEPTION;
dup_des                   EXCEPTION;


CURSOR c1 IS
select contadores.ID, n_anyos,modelos.ANYOFABRICA
from contadores, modelos
where contadores.MODELO = modelos.ID
and   modelos.ANYOFABRICA < (to_char(sysdate,'YYYY')- n_anyos );


BEGIN
contador := 1;
--verificamos que los campos no nulos no sean nulos
IF (n_anyos   IS NULL)
THEN RAISE dup_des;
END IF;

select count(*)
INTO contadores_test 
from contadores, modelos
where contadores.MODELO = modelos.ID
and   modelos.ANYOFABRICA < (to_char(sysdate,'YYYY') - n_anyos );
IF (contadores_test = 0)
THEN
RAISE dup_contadores;
END IF;
 DBMS_OUTPUT.ENABLE(250);
 DBMS_OUTPUT.PUT_LINE('');
 DBMS_OUTPUT.PUT_LINE('CONSULTA DE CONTADORES CON ANTIGEDAD DE ' || n_anyos || ' aos') ;
 DBMS_OUTPUT.PUT_LINE('-------------------------------------------------');
  --abrir el cursor e insertar en la tabla correspondiente
        OPEN c1;
               FETCH c1 INTO n_contador ,n_anyos_ins, n_fabrica ;
               WHILE c1%FOUND  LOOP
                   FETCH c1 INTO n_contador, n_anyos_ins,n_fabrica ;
                      DBMS_OUTPUT.PUT_LINE(' Contador: ' ||n_contador||' Num. aos: ' ||n_anyos_ins ||' Fabricado en:  ' ||n_fabrica);
                      rst :='OK';
                      altaC7(n_contador, n_anyos, n_fabrica,rst);
                  END LOOP;
       CLOSE c1;

-- Fin de las operaciones
 
    rst:='Ok, Alta consultarContadoresAntiguedad   realizada con exito';
       
altaLog('Proc. consultaC7', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
'n_contador: ' 
|| n_contador 
||' n_anyo  : '
|| n_anyo
, 'rst', rst, rst);

COMMIT;

-- controlamos las excepciones
EXCEPTION

WHEN dup_contadores
THEN

    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('');
    DBMS_OUTPUT.PUT_LINE(' n_contador : ' || n_contador  ); 
     rst := 'ERROR: No hay contadores con los aos de antigedad';
    DBMS_OUTPUT.PUT_LINE('');  
    DBMS_OUTPUT.PUT_LINE(rst);
    
altaLog('Proc. consultaC7', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
' n_anyos '
|| n_anyos
, 'rst', rst, rst);

ROLLBACK;

WHEN dup_des
THEN
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('');
    rst := 'ERROR: hay campos no nulos  sin contenido';
    DBMS_OUTPUT.PUT_LINE('');  
    DBMS_OUTPUT.PUT_LINE(rst);
  
altaLog('Proc. consultaC7', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
'n_anyos' 
|| n_anyos
, 'rst', rst, rst);

ROLLBACK;
WHEN OTHERS
THEN
err_msg := SUBSTR (SQLERRM, 1, 100);
rst := 'ERROR:'
|| err_msg;
altaLog('Proc. consultaC7', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
'n_anyos ' || n_anyos 
, 'rst', rst, rst);
ROLLBACK;
END consultaC7;
/
--PRUEBA DE USO C7
declare rst varchar2(250);
begin
consultaC7(5, rst);
end;
/