CREATE OR REPLACE
PROCEDURE altaE3(
n_linea				IN NUMBER,
n_consumoContadores             IN NUMBER,
n_fecha                         IN VARCHAR,
rst OUT VARCHAR2
)
IS
/******************************************************************************
NOMBRE: altaE3
PROPSITO: gestiona el alta en la tabla estadstica E_3
PARAMETERS: n_lina,n_anyo, n_consumoContadores, n_fecharst
INPUT:      n_lina,n_anyo, n_consumoContadores, n_fecha
OUTPUT: rst
RETORNA: 'OK' si la operacin ha tenido xito, 'ERROR: Tipo de Error' en caso contrario
EJEMPLO DE USO: altaE3(1,200,to_char(sysdate,'DD/MM/YYYY'),rst);
******************************************************************************/
--definicion de variables
n_fecha_ins     VARCHAR2(11);
linea_test	INTEGER;
err_msg       	VARCHAR2 (100);
dup_linea	EXCEPTION;
des_nulo      	EXCEPTION;

BEGIN
-- comprobar logitudes
n_fecha_ins  := SUBSTR (n_fecha ,1,11);

--verificamos si hay campos no nulos: nulos
IF 	   (n_linea			IS NULL)
	OR (n_consumoContadores 	IS NULL)
        OR (n_fecha_ins          	IS NULL)
THEN
RAISE des_nulo;
END IF;



--comprobar que la linea existe
SELECT count(*)
INTO linea_test
FROM linea
WHERE linea.id = n_linea;
IF (linea_test = 0)
THEN
RAISE dup_linea;
END IF;
-- insertamos en E3
INSERT INTO E_3(linea,consumoContadores,fecha)
VALUES (n_linea,n_consumoContadores,n_fecha_ins);
-- Fin de las operaciones

    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('');
    DBMS_OUTPUT.PUT_LINE('Alta de E3: '  || 'n_linea: '  ||  n_linea); 
    DBMS_OUTPUT.PUT_LINE('Alta de E3: '  || 'n_consumoContadores: '  ||  n_consumoContadores); 
    DBMS_OUTPUT.PUT_LINE('Alta de E3: '  || 'n_fecha: '  ||  n_fecha_ins); 

    rst:='OK, Alta de E3  realizada con exito';
    DBMS_OUTPUT.PUT_LINE('');  
    DBMS_OUTPUT.PUT_LINE(rst); 

--rst := 'OK';
altaLog('Proc. altaE3', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
    'n_linea: '
    ||  n_linea
    || '  n_consumoContadores: '
    ||  n_consumoContadores
    || '  n_fecha: '
    ||  n_fecha_ins
   , 'rst', rst, rst);
COMMIT;

-- control de excepciones
EXCEPTION

WHEN des_nulo
THEN
    rst := 'ERROR: hay campos no nulos: vacios';
    DBMS_OUTPUT.PUT_LINE('');  
    DBMS_OUTPUT.PUT_LINE(rst);
altaLog('Proc. altaE3', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
     'n_linea: '
    ||  n_linea
    || '  n_consumoContadores: '
    ||  n_consumoContadores
    || '  n_fecha: '
    ||  n_fecha_ins
    , 'rst', rst, rst);
ROLLBACK;

WHEN dup_linea
THEN
    rst := 'ERROR: NO existe la linea';
    DBMS_OUTPUT.PUT_LINE('');  
    DBMS_OUTPUT.PUT_LINE(rst);
altaLog('Proc. altaE3', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
    'n_linea: '
    ||  n_linea
    || '  n_consumoContadores: '
    ||  n_consumoContadores
    || '  n_fecha: '
    ||  n_fecha_ins
, 'rst', rst, rst);
ROLLBACK;

WHEN OTHERS
THEN
err_msg := SUBSTR (SQLERRM, 1, 100);
rst := 'ERROR:'
|| err_msg;
altaLog('Proc. altaE3', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
     'n_linea: '
    ||  n_linea
    || '  n_consumoContadores: '
    ||  n_consumoContadores
    || '  n_fecha: '
    ||  n_fecha_ins
    , 'rst', rst, rst);
ROLLBACK;
END altaE3;
/