CREATE OR REPLACE
PROCEDURE altaE4(
n_anyo  		IN NUMBER,
n_perLineaMas50         IN NUMBER,
rst OUT VARCHAR2
)
IS
/******************************************************************************
NOMBRE: altaE4
PROPSITO: gestiona el alta en la tabla estadstica 
            Dado un ao en concreto: porcentaje de lineas que superan 50% de energia consumida.
PARAMETERS: n_anyo, n_perLineaMas50, rst
INPUT:      n_anyo, n_perLineaMas50
OUTPUT: rst
RETORNA: 'OK' si la operacin ha tenido xito, 'ERROR: Tipo de Error' en caso contrario
EJEMPLO DE USO: altaE4(2012,90,rst);
******************************************************************************/
--definicion de variables
--n_anyo_ins        VARCHAR2(4 CHAR);
err_msg       	  VARCHAR2 (100);
des_nulo      	  EXCEPTION;

BEGIN
--control de la longitud de cadenas
--n_anyo_ins := SUBSTR (n_anyo, 1, 4);

--verificamos si hay campos no nulos: nulos
IF 	   (n_anyo			IS NULL)
	OR (n_perLineaMas50 	        IS NULL)
THEN
RAISE des_nulo;
END IF;
-- insertamos en E4
INSERT INTO E_4(anyo,perLineaMas50) VALUES (n_anyo, n_perLineaMas50);

-- Fin de las operaciones
-- pantalla
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('');
    DBMS_OUTPUT.PUT_LINE('Alta de E4: '  || 'n_anyo: '  ||  n_anyo); 
    DBMS_OUTPUT.PUT_LINE('Alta de E4: '  || 'n_perLineaMas50: '  ||  n_perLineaMas50); 
    rst:='OK, Alta de E4  realizada con exito';
    DBMS_OUTPUT.PUT_LINE('');  
    DBMS_OUTPUT.PUT_LINE(rst); 

--rst := 'OK';
altaLog('Proc. altaE4', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
    ' n_anyo: '
    ||  n_anyo
    || '  n_perLineaMas50: '
    ||  n_perLineaMas50
   , 'rst', rst, rst);
COMMIT;

-- control de excepciones
EXCEPTION

WHEN des_nulo
THEN
    rst := 'ERROR: hay campos no nulos: vacios';
    DBMS_OUTPUT.PUT_LINE('');  
    DBMS_OUTPUT.PUT_LINE(rst);
altaLog('Proc. altaE4', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
      ' n_anyo: '
    ||  n_anyo
    || '  n_perLineaMas50: '
    ||  n_perLineaMas50
    , 'rst', rst, rst);
ROLLBACK;

WHEN OTHERS
THEN
err_msg := SUBSTR (SQLERRM, 1, 100);
rst := 'ERROR:'
|| err_msg;
altaLog('Proc. altaE4', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
      ' n_anyo: '
    ||  n_anyo
    || '  n_perLineaMas50: '
    ||  n_perLineaMas50
    , 'rst', rst, rst);
ROLLBACK;
END altaE4;
/