CREATE OR REPLACE
PROCEDURE altaE5(
n_anyo  		        IN NUMBER,
n_cenProduccionMenos30          IN NUMBER,
rst OUT VARCHAR2
)
IS
/******************************************************************************
NOMBRE: altaE5
PROPSITO: gestiona el alta en la tabla estadstica 
            Dado un ao en concreto: el numero de centrales de produccion que generan menos del  30% de produccin.
PARAMETERS: n_anyo, cenProduccionMenos30, rst
INPUT:      n_anyo, cenProduccionMenos30 
OUTPUT: rst
RETORNA: 'OK' si la operacin ha tenido xito, 'ERROR: Tipo de Error' en caso contrario
EJEMPLO DE USO: altaE5('2012',90,rst);
******************************************************************************/
--definicion de variables
--n_anyo_ins        VARCHAR2(4 CHAR);
err_msg       	  VARCHAR2 (100);
des_nulo      	  EXCEPTION;

BEGIN
--control de la longitud de cadenas
--n_anyo_ins := SUBSTR (n_anyo, 1, 4);

--verificamos si hay campos no nulos: nulos
IF 	   (n_anyo			        IS NULL)
	OR (n_cenProduccionMenos30 	        IS NULL)
THEN
RAISE des_nulo;
END IF;
-- insertamos en E4
INSERT INTO E_5(anyo,cenProduccionMenos30) VALUES (n_anyo, n_cenProduccionMenos30);

-- Fin de las operaciones
-- pantalla
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('');
    DBMS_OUTPUT.PUT_LINE('Alta de E5: '  || 'n_anyo: '  ||  n_anyo); 
    DBMS_OUTPUT.PUT_LINE('Alta de E5: '  || 'n_cenProduccionMenos30: '  ||  n_cenProduccionMenos30); 
    rst:='OK, Alta de E5  realizada con exito';
    DBMS_OUTPUT.PUT_LINE('');  
    DBMS_OUTPUT.PUT_LINE(rst); 

--rst := 'OK';
altaLog('Proc. altaE5', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
    'n_anyo: '
    ||  n_anyo
    || '  n_cenProduccionMenos30: '
    ||  n_cenProduccionMenos30
   , 'rst', rst, rst);
COMMIT;

-- control de excepciones
EXCEPTION

WHEN des_nulo
THEN
    rst := 'ERROR: hay campos no nulos: vacios';
    DBMS_OUTPUT.PUT_LINE('');  
    DBMS_OUTPUT.PUT_LINE(rst);
altaLog('Proc. altaE4', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
      'n_anyo: '
    ||  n_anyo
    || '  n_cenProduccionMenos30: '
    ||  n_cenProduccionMenos30
    , 'rst', rst, rst);
ROLLBACK;

WHEN OTHERS
THEN
err_msg := SUBSTR (SQLERRM, 1, 100);
rst := 'ERROR:'
|| err_msg;
altaLog('Proc. altaE5', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
      'n_anyo: '
    ||  n_anyo
    || '  n_cenProduccionMenos30: '
    ||  n_cenProduccionMenos30
    , 'rst', rst, rst);
ROLLBACK;
END altaE5;
/