CREATE OR REPLACE
PROCEDURE altaE7(
n_cliente  	      IN NUMBER,
n_consumoMedio        IN NUMBER,
rst OUT VARCHAR2
)
IS

/******************************************************************************
NOMBRE: altaE7
PROPSITO: gestiona el alta en la tabla estadstica E_7
            Consumo medio de todos los clientes.
PARAMETERS: n_contador,n_consumo, rst
INPUT:      n_contador,n_consumo
OUTPUT: rst
RETORNA: 'OK' si la operacin ha tenido xito, 'ERROR: Tipo de Error' en caso contrario
EJEMPLO DE USO: altaE7(2,90,rst);
******************************************************************************/
--definicion de variables
cliente_test      INTEGER;
err_msg       	  VARCHAR2 (100);
dup_cliente       EXCEPTION;
des_nulo      	  EXCEPTION;

BEGIN


--verificamos si hay campos no nulos: nulos
IF 	   (n_cliente           IS NULL)
	OR (n_consumoMedio      IS NULL)
THEN
RAISE des_nulo;
END IF;

--Verificamos exista el  cliente 
SELECT COUNT (*)
INTO cliente_test
FROM clientes
WHERE clientes.ID = n_cliente;
IF (cliente_test = 0)
THEN
RAISE dup_cliente;
END IF;

-- insertamos en E7
INSERT INTO E_7(cliente,consumoMedio) VALUES (n_cliente, n_consumoMedio);

-- Fin de las operaciones
-- pantalla
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('');
    DBMS_OUTPUT.PUT_LINE('Alta de E_7: '  || 'n_cliente: '  ||  n_cliente); 
    DBMS_OUTPUT.PUT_LINE('Alta de E_7: '  || 'n_consumoMedio : '  ||  n_consumoMedio ); 
    rst:='OK, Alta de E_7  realizada con exito';
    DBMS_OUTPUT.PUT_LINE('');  
    DBMS_OUTPUT.PUT_LINE(rst); 

--rst := 'OK';
altaLog('Proc. altaE7', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
    'n_cliente: '
    ||  n_cliente
    || '  n_consumoMedio: '
    ||  n_consumoMedio
   , 'rst', rst, rst);
COMMIT;

-- control de excepciones
EXCEPTION

WHEN des_nulo
THEN
    rst := 'ERROR: hay campos no nulos: vacios';
    DBMS_OUTPUT.PUT_LINE('');  
    DBMS_OUTPUT.PUT_LINE(rst);
altaLog('Proc. altaE7', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
     'n_cliente: '
    ||  n_cliente
    || '  n_consumoMedio: '
    ||  n_consumoMedio
    , 'rst', rst, rst);
ROLLBACK;
WHEN dup_cliente
THEN
    rst := 'ERROR: NO existe el Cliente';
    DBMS_OUTPUT.PUT_LINE('');  
    DBMS_OUTPUT.PUT_LINE(rst); 
altaLog('Proc. altaE6', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
   'n_cliente: '
    ||  n_cliente
    || '  n_consumoMedio: '
    ||  n_consumoMedio
, 'rst', rst, rst);
ROLLBACK;

WHEN OTHERS
THEN
err_msg := SUBSTR (SQLERRM, 1, 100);
rst := 'ERROR:'
|| err_msg;
altaLog('Proc. altaE7', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
    'n_cliente: '
    ||  n_cliente
    || '  n_consumoMedio: '
    ||  n_consumoMedio
    , 'rst', rst, rst);
ROLLBACK;
END altaE7;
/