CREATE OR REPLACE
PROCEDURE bajaE2(
n_id				IN NUMBER,
rst OUT VARCHAR2
)
IS
/******************************************************************************
NOMBRE: bajaE2
PROPSITO: baja del registro en la  la tabla estadstica E_2
Dada una lnea de comunicacin y un ao en concreto, el valor medio de la energa consumida
si el contador hace servir dos lineas, computa en las dos
PARAMETERS: n_id, rst
INPUT: n_id
OUTPUT: rst
RETORNA: 'OK' si la operacin ha tenido xito, 'ERROR: Tipo de Error' en caso contrario
EJEMPLO DE USO: bajaE2(1,rst);
******************************************************************************/
--definicion de variables

id_test         INTEGER;
err_msg       	VARCHAR2 (100);
dup_id          EXCEPTION;
des_nulo      	EXCEPTION;

BEGIN

--verificamos si hay campos no nulos: nulos
 	   
IF 	   (n_id  IS NULL)

THEN
RAISE des_nulo;
END IF;

--verfico que existe el id 
SELECT COUNT(*)
INTO id_test
FROM E_2
WHERE E_2.ID = n_id;
IF (id_test=0)
THEN
RAISE dup_id;
END IF;

--borramos registro de  E2
DELETE
FROM E_2
WHERE id=n_id;

-- Fin de las operaciones

    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('');
    DBMS_OUTPUT.PUT_LINE('Baja del registro  E_2: '  || 'n_id: '  ||  n_id); 
    rst:='OK, Baja del registro E_2:  realizada con exito';
    DBMS_OUTPUT.PUT_LINE('');  
    DBMS_OUTPUT.PUT_LINE(rst); 

--rst := 'OK';
altaLog('Proc. bajaE2', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
    'n_id: '
    ||  n_id
   , 'rst', rst, rst);
COMMIT;

-- control de excepciones
EXCEPTION

WHEN des_nulo
THEN
    rst := 'ERROR: hay campos no nulos: vacios';
    DBMS_OUTPUT.PUT_LINE('');  
    DBMS_OUTPUT.PUT_LINE(rst);
altaLog('Proc. bajaE2', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
     'n_id: '
    ||  n_id
    , 'rst', rst, rst);
ROLLBACK;


WHEN dup_id
THEN
    rst := 'ERROR: NO existe el registro ';
    DBMS_OUTPUT.PUT_LINE('');  
    DBMS_OUTPUT.PUT_LINE(rst);
altaLog('Proc. bajaE2', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
    'n_id: '
    ||  n_id
, 'rst', rst, rst);
ROLLBACK;

WHEN OTHERS
THEN
err_msg := SUBSTR (SQLERRM, 1, 100);
rst := 'ERROR:'
|| err_msg;
altaLog('Proc. bajaE2', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
     'n_id: '
    ||  n_id
     , 'rst', rst, rst);
ROLLBACK;
END bajaE2;
/