CREATE OR REPLACE
PROCEDURE bajaE3(

n_id 	IN NUMBER,
rst OUT VARCHAR2
)
IS
/******************************************************************************
NOMBRE: bajaE3
PROPSITO: gestiona la baja la tabla estadstica E_3
PARAMETERS: n_id,rst
INPUT:      n_id
OUTPUT: rst
RETORNA: 'OK' si la operacin ha tenido xito, 'ERROR: Tipo de Error' en caso contrario
EJEMPLO DE USO: bajaE3(1,rst);
******************************************************************************/
--definicion de variables
id_test INTEGER;
err_msg       	VARCHAR2 (100);
dup_id EXCEPTION;
des_nulo      	EXCEPTION;

BEGIN

--verificamos si hay campos no nulos: nulos
IF (n_id		IS NULL)

THEN
RAISE des_nulo;
END IF;



--verfico que existe el id 
SELECT COUNT(*)
INTO id_test
FROM E_3
WHERE E_3.ID = n_id;
IF (id_test=0)
THEN
RAISE dup_id;
END IF;


--borrar registro  E3
DELETE FROM E_3
WHERE id = n_id;

-- Fin de las operaciones

    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('');
    DBMS_OUTPUT.PUT_LINE('Borrar registro  E3: '  || 'n_id: '  ||  n_id); 
    rst:='OK, Borrar registro de E3  realizado con exito';
    DBMS_OUTPUT.PUT_LINE('');  
    DBMS_OUTPUT.PUT_LINE(rst); 

--rst := 'OK';
altaLog('Proc. bajaE3', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
    'n_id: '
    ||  n_id
   , 'rst', rst, rst);
COMMIT;

-- control de excepciones
EXCEPTION

WHEN des_nulo
THEN
    rst := 'ERROR: hay campos no nulos: vacios';
    DBMS_OUTPUT.PUT_LINE('');  
    DBMS_OUTPUT.PUT_LINE(rst);
altaLog('Proc. bajaE3', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
	'n_id: '
    ||  n_id
    , 'rst', rst, rst);
ROLLBACK;



WHEN dup_id
THEN
    rst := 'ERROR: NO existe el registro ';
    DBMS_OUTPUT.PUT_LINE('');  
    DBMS_OUTPUT.PUT_LINE(rst);
altaLog('Proc. bajaE3', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
	'n_id: '
    ||  n_id
   , 'rst', rst, rst);
ROLLBACK;



WHEN OTHERS
THEN
err_msg := SUBSTR (SQLERRM, 1, 100);
rst := 'ERROR:'
|| err_msg;
altaLog('Proc. BajaE3', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
	'n_id: '
    ||  n_id
    , 'rst', rst, rst);
ROLLBACK;
END bajaE3;
/