CREATE OR REPLACE
PROCEDURE bajaE6(
n_id			IN NUMBER,
rst OUT VARCHAR2
)
IS
/******************************************************************************
NOMBRE: bajaE6
PROPSITO: gestiona el borrado del registro en la tabla estadstica 
            Dado un ao en concreto: el numero de centrales de produccion que generan menos del  30% de produccin.
PARAMETERS: n_id,n_contador,n_consumo, rst
INPUT:      n_id,n_contador,n_consumo
OUTPUT: rst
RETORNA: 'OK' si la operacin ha tenido xito, 'ERROR: Tipo de Error' en caso contrario
EJEMPLO DE USO: bajaE6(1,rst);
******************************************************************************/
--definicion de variables
id_test			INTEGER;
err_msg       	  VARCHAR2 (100);
dup_id            EXCEPTION;
des_nulo      	  EXCEPTION;

BEGIN


--verificamos si hay campos no nulos: nulos
IF 	   (n_id 			IS NULL)
	
THEN
RAISE des_nulo;
END IF;



--Verificamos exista el  registro 
SELECT COUNT (*)
INTO id_test
FROM E_6
WHERE E_6.ID = n_id;
IF (id_test = 0)
THEN
RAISE dup_id;
END IF;


--borramos el registro de E_6
DELETE FROM  E_6
WHERE id = n_id;

-- Fin de las operaciones
-- pantalla
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('');
    DBMS_OUTPUT.PUT_LINE('Borrar el registro de  E6: '  || 'n_id: '  ||  n_id); 
    rst:='OK, Modifica de E6  realizada con exito';
    DBMS_OUTPUT.PUT_LINE('');  
    DBMS_OUTPUT.PUT_LINE(rst); 

--rst := 'OK';
altaLog('Proc. bajaE6', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
    'n_id: '
    ||  n_id
    , 'rst', rst, rst);
COMMIT;

-- control de excepciones
EXCEPTION

WHEN des_nulo
THEN
    rst := 'ERROR: hay campos no nulos: vacios';
    DBMS_OUTPUT.PUT_LINE('');  
    DBMS_OUTPUT.PUT_LINE(rst);
altaLog('Proc. bajaE6', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
     'n_id: '
    ||  n_id
    , 'rst', rst, rst);
ROLLBACK;

WHEN dup_id
THEN
    rst := 'ERROR: NO existe el Registro';
    DBMS_OUTPUT.PUT_LINE('');  
    DBMS_OUTPUT.PUT_LINE(rst); 
altaLog('Proc. bajaE6', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
 	'n_id: '
    ||  n_id
, 'rst', rst, rst);
ROLLBACK;


WHEN OTHERS
THEN
err_msg := SUBSTR (SQLERRM, 1, 100);
rst := 'ERROR:'
|| err_msg;
altaLog('Proc. bajaE6', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
   'n_id: '
    ||  n_id
    , 'rst', rst, rst);
ROLLBACK;
END bajaE6;
/