CREATE OR REPLACE
PROCEDURE bajaE7(
n_id		      IN NUMBER,
rst OUT VARCHAR2
)
IS
/******************************************************************************
NOMBRE: bajaE7
PROPSITO: gestiona la baja del registro  en la tabla estadstica E_7
            Consumo medio de todos los clientes.
PARAMETERS: n_id,rst
INPUT:      n_id
OUTPUT: rst
RETORNA: 'OK' si la operacin ha tenido xito, 'ERROR: Tipo de Error' en caso contrario
EJEMPLO DE USO: bajaE7(1,rst);
******************************************************************************/
--definicion de variables
id_test		  INTEGER;
err_msg       	  VARCHAR2 (100);
des_nulo      	  EXCEPTION;
dup_id		  EXCEPTION;
BEGIN


--verificamos si hay campos no nulos: nulos
    IF 	   (n_id 	        IS NULL)
THEN
RAISE des_nulo;
END IF;


--Borrar registro de  E7
DELETE FROM E_7
WHERE id = n_id;

-- Fin de las operaciones
-- pantalla
    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('');
    DBMS_OUTPUT.PUT_LINE('Borrar registro de  E_7: '  || 'n_id: '  ||  n_id); 
    rst:='OK, Borrar registro de E7 realizado con exito';
    DBMS_OUTPUT.PUT_LINE('');  
    DBMS_OUTPUT.PUT_LINE(rst); 

--rst := 'OK';
altaLog('Proc. bajaE7', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
    'n_id : '
    ||  n_id
       , 'rst', rst, rst);
COMMIT;

-- control de excepciones
EXCEPTION

WHEN des_nulo
THEN
    rst := 'ERROR: hay campos no nulos: vacios';
    DBMS_OUTPUT.PUT_LINE('');  
    DBMS_OUTPUT.PUT_LINE(rst);
altaLog('Proc. bajaE7', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
     'n_id: '
    ||  n_id
       , 'rst', rst, rst);
ROLLBACK;


WHEN dup_id
THEN
    rst := 'ERROR: NO existe el Registro';
    DBMS_OUTPUT.PUT_LINE('');  
    DBMS_OUTPUT.PUT_LINE(rst); 
altaLog('Proc. bajaE7', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
   'n_id: '
    ||  n_id
    , 'rst', rst, rst);
ROLLBACK;

WHEN OTHERS
THEN
err_msg := SUBSTR (SQLERRM, 1, 100);
rst := 'ERROR:'
|| err_msg;
altaLog('Proc. bajaE7', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
    'n_id: '
    ||  n_id
    , 'rst', rst, rst);
ROLLBACK;
END bajaE7;
/