CREATE OR REPLACE
PROCEDURE modificaE3(

n_id 	IN NUMBER,
n_linea				IN NUMBER,
n_consumoContadores             IN NUMBER,
rst OUT VARCHAR2
)
IS
/******************************************************************************
NOMBRE: altaE2
PROPSITO: gestiona el alta en la tabla estadstica E_3
PARAMETERS: n_lina,n_anyo, n_consumoContadores rst
INPUT:      n_lina,n_anyo, n_consumoContadores
OUTPUT: rst
RETORNA: 'OK' si la operacin ha tenido xito, 'ERROR: Tipo de Error' en caso contrario
EJEMPLO DE USO: modificaE3(1,200,rst);
******************************************************************************/
--definicion de variables
id_test INTEGER;
linea_test	INTEGER;
err_msg       	VARCHAR2 (100);
dup_id EXCEPTION;
dup_linea	EXCEPTION;
des_nulo      	EXCEPTION;

BEGIN

--verificamos si hay campos no nulos: nulos
IF (n_id		IS NULL)
	 OR  (n_linea			IS NULL)
	OR (n_consumoContadores 	IS NULL)
THEN
RAISE des_nulo;
END IF;

--comprobar que la linea existe
SELECT count(*)
INTO linea_test
FROM linea
WHERE linea.id = n_linea;
IF (linea_test = 0)
THEN
RAISE dup_linea;
END IF;


--verfico que existe el id 
SELECT COUNT(*)
INTO id_test
FROM E_3
WHERE E_3.ID = n_id;
IF (id_test=0)
THEN
RAISE dup_id;
END IF;


--modificamos E3
UPDATE E_3
SET
linea= n_linea,
consumoContadores = n_consumoContadores
WHERE id = n_id;

-- Fin de las operaciones

    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('');
    DBMS_OUTPUT.PUT_LINE('modifica  E3: '  || 'n_linea: '  ||  n_linea); 
    DBMS_OUTPUT.PUT_LINE('modifica  E3: '  || 'n_consumoContadores: '  ||  n_consumoContadores); 
    rst:='OK, Alta de E3  realizada con exito';
    DBMS_OUTPUT.PUT_LINE('');  
    DBMS_OUTPUT.PUT_LINE(rst); 

--rst := 'OK';
altaLog('Proc. modificaE3', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
    'n_linea: '
    ||  n_linea
    || '  n_consumoContadores: '
    ||  n_consumoContadores
   , 'rst', rst, rst);
COMMIT;

-- control de excepciones
EXCEPTION

WHEN des_nulo
THEN
    rst := 'ERROR: hay campos no nulos: vacios';
    DBMS_OUTPUT.PUT_LINE('');  
    DBMS_OUTPUT.PUT_LINE(rst);
altaLog('Proc. modificaE3', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
     'n_linea: '
    ||  n_linea
    || '  n_consumoContadores: '
    ||  n_consumoContadores
    , 'rst', rst, rst);
ROLLBACK;


WHEN dup_linea
THEN
    rst := 'ERROR: NO existe la linea';
    DBMS_OUTPUT.PUT_LINE('');  
    DBMS_OUTPUT.PUT_LINE(rst);
altaLog('Proc. modificaE3', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
    'n_linea: '
    ||  n_linea
    || '  n_consumoContadores: '
    ||  n_consumoContadores
, 'rst', rst, rst);
ROLLBACK;

WHEN dup_id
THEN
    rst := 'ERROR: NO existe el registro ';
    DBMS_OUTPUT.PUT_LINE('');  
    DBMS_OUTPUT.PUT_LINE(rst);
altaLog('Proc. modificaE3', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
    'n_linea: '
    ||  n_linea
    || '  n_consumoContadores: '
    ||  n_consumoContadores
   , 'rst', rst, rst);
ROLLBACK;



WHEN OTHERS
THEN
err_msg := SUBSTR (SQLERRM, 1, 100);
rst := 'ERROR:'
|| err_msg;
altaLog('Proc. altaE2', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
     'n_linea: '
    ||  n_linea
    || '  n_consumoContadores: '
    ||  n_consumoContadores
    , 'rst', rst, rst);
ROLLBACK;
END modificaE3;
/