create or replace PROCEDURE modificaClaseCentral(
n_id 	 IN NUMBER,
n_des IN VARCHAR2,
rst OUT VARCHAR2
)
IS
/******************************************************************************
NOMBRE: modificaClaseCentral
PROPSITO: gestiona la modificacin de una Clase de Central
PARAMETERS: n_id,n_des, rst
INPUT: n_id,n_des
OUTPUT: rst
RETORNA: 'OK' si la operacin ha sido exitosa, 'ERROR: Tipo de Error' en
caso contrario
EJEMPLO DE USO: modificaClaseCentral(1,'DISTRIBUCIN', rst);
******************************************************************************/
n_des_ins       		VARCHAR2 (50);
id_test        		        INTEGER;
des_test        		INTEGER;
err_msg         		VARCHAR2 (100);
dup_id			        EXCEPTION;
dup_ccentral    		EXCEPTION;
desCCentral_nulo  	        EXCEPTION;
BEGIN
n_des_ins := SUBSTR (n_des, 1, 50);
--Verificamos si el codigo de la clase de central existe
SELECT COUNT (*)
INTO id_test
FROM ccentral
WHERE ID = n_id;
IF (id_test = 0)
THEN
RAISE dup_id;
END IF;
--verificamos si el campo CCENTRAL.des es nulo
IF (n_des_ins IS NULL) THEN
RAISE desCCentral_nulo;
END IF;
--verificamos si existe la descripcion de la central
/*
SELECT COUNT (*)
INTO des_test
FROM ccentral
WHERE des = n_des_ins;
IF (des_test = 0)
THEN
RAISE dup_ccentral;
END IF;
*/
-- modificamos la  clase de central
UPDATE ccentral
SET
des = n_des_ins
WHERE
ccentral.id = n_id;
-- Fin de las operaciones

    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('');
    DBMS_OUTPUT.PUT_LINE('Modificado  tipo de CCENTRAL: ' || n_id); 
    rst:='Ok, Modifica Tipo CCENTRAL  realizada con exito';
    DBMS_OUTPUT.PUT_LINE('');  
    DBMS_OUTPUT.PUT_LINE(rst); 

--rst := 'OK';
altaLog('Proc. modificaClaseCentral', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
'Tipo de CCENTRAL:' || n_des, 'rst', rst, rst);
COMMIT;
EXCEPTION
WHEN dup_id
THEN
    rst := 'ERROR: No existe este cdigo localidad';
    DBMS_OUTPUT.PUT_LINE('');  
    DBMS_OUTPUT.PUT_LINE(rst); 
altaLog('Proc. modificaClaseCentral', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
'Tipo de CCENTRAL: ' || n_des
, 'rst', rst, rst);
ROLLBACK;

WHEN dup_ccentral
THEN
    rst := 'ERROR: Ya existe este nombre de   CCENTRAL';
    DBMS_OUTPUT.PUT_LINE('');  
    DBMS_OUTPUT.PUT_LINE(rst); 
altaLog('Proc. modificaClaseCentral', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
'Tipo de CCENTRAL: ' || n_des, 'rst', rst, rst);
ROLLBACK;
WHEN desCCentral_nulo
THEN
    rst := 'ERROR: el tipo de CCENTRAL  no debe ser nulo';
    DBMS_OUTPUT.PUT_LINE('');  
    DBMS_OUTPUT.PUT_LINE(rst);
altaLog('Proc. modificaClaseCentral', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
'Tipo de CCENTRAL: ' || n_des, 'rst', rst, rst);
ROLLBACK;
WHEN OTHERS
THEN
err_msg := SUBSTR (SQLERRM, 1, 100);
rst := 'ERROR:'
|| err_msg;
altaLog('Proc. modificaClaseCentral', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
'Tipo de CCENTRAL: ' || n_des, 'rst', rst, rst);
ROLLBACK;
END modificaClaseCentral;
/