CREATE OR REPLACE
PROCEDURE modificaConsumos(
n_id		    IN NUMBER,	
n_contador          IN NUMBER,
n_anyo     	    IN NUMBER,
n_mes               IN NUMBER,
n_consumo           IN NUMBER,
rst                 OUT VARCHAR2
)
IS
/******************************************************************************
NOMBRE: modificaConsumos
PROPSITO: gestiona el alta en la tabla de consumos
PARAMETERS:  n_id,n_contador,n_anyo, n_mes,n_consumo, rst
INPUT:   n_id,n_contador, n_anyo,n_mes,n_consumo
OUTPUT: rst
RETORNA: 'OK' si la operacin ha tenido exito, 'ERROR: Tipo de Error' en caso contrario
EJEMPLO DE USO: modificaConsumos(1,1,2012,2,12 rst);
******************************************************************************/
id_test			INTEGER;
contador_test           INTEGER;
err_msg                 VARCHAR2 (100);
dup_id			EXCEPTION;
dup_contador            EXCEPTION;
dup_null                EXCEPTION;

BEGIN

--comprobamos campos no nulos que no esten vacios
IF (n_contador          IS NULL)
OR (n_anyo              IS NULL)
OR (n_mes               IS NULL)
OR (n_consumo           IS NULL)
THEN
RAISE dup_null;
END IF;
--Verificamos exista el  el id de consumos 
SELECT COUNT (*)
INTO id_test
FROM consumos
WHERE consumos.ID = n_id;
IF (contador_test = 0)
THEN
RAISE dup_id;
END IF;

--Verificamos exista el  contador 
SELECT COUNT (*)
INTO contador_test
FROM CONTADORES
WHERE CONTADORES.ID = n_contador;
IF (contador_test = 0)
THEN
RAISE dup_contador;
END IF;


-- modificamos el registro de consumos
UPDATE  consumos
SET
contador  	= n_contador
,anyo 	        = n_anyo
,mes 		= n_mes
,consumo 	= n_consumo
Where
consumos.id = n_id;
-- Fin de las operaciones
--rst := 'OK';
  DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('');
    DBMS_OUTPUT.PUT_LINE('Consumo modificado: ' || n_contador 
    ||','|| n_anyo 
    ||','||n_mes  
    ||','||n_consumo
    ); 
    rst:='Ok, modificaConsumos   realizado con exito';
    DBMS_OUTPUT.PUT_LINE('');  
    DBMS_OUTPUT.PUT_LINE(rst);

altaLog('Proc. modificaConsumos', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
'n_contador: '
||n_contador
||' n_anyo: '
|| n_anyo
||' n_mes: '
||n_mes
||' n_consumo: '
|| n_consumo
, 'rst', rst, rst);
COMMIT;

EXCEPTION

WHEN dup_id
THEN
    rst := 'ERROR: NO existe el id de Consumos';
    DBMS_OUTPUT.PUT_LINE('');  
    DBMS_OUTPUT.PUT_LINE(rst); 
altaLog('Proc. modificaConsumos', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
'n_id'
|| n_id
||' n_contador: '
||n_contador
||' n_fechaLectura: '
||' n_anyo: '
|| n_anyo
||' n_mes: '
||n_mes
||' n_consumo: '
|| n_consumo
, 'rst', rst, rst);
ROLLBACK;

WHEN dup_contador
THEN
    rst := 'ERROR: NO existe el CONTADOR';
    DBMS_OUTPUT.PUT_LINE('');  
    DBMS_OUTPUT.PUT_LINE(rst); 
altaLog('Proc. modificaConsumos', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
'n_id'
|| n_id
||' n_contador: '
||n_contador
||' n_fechaLectura: '
||' n_anyo: '
|| n_anyo
||' n_mes: '
||n_mes
||' n_consumo: '
|| n_consumo
, 'rst', rst, rst);
ROLLBACK;


WHEN dup_null
THEN
    rst := 'ERROR: hay campos NO nulos, sin contenido';
    DBMS_OUTPUT.PUT_LINE('');  
    DBMS_OUTPUT.PUT_LINE(rst);
altaLog('Proc. modificaConsumos', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
'n_id'
|| n_id
||' n_contador: '
||n_contador
||' n_anyo: '
|| n_anyo
||' n_mes: '
||n_mes
||' n_consumo: '
|| n_consumo
, 'rst', rst, rst);
ROLLBACK;

WHEN OTHERS
THEN
err_msg := SUBSTR (SQLERRM, 1, 100);
rst := 'ERROR:'
|| err_msg;
altaLog('Proc. modificaConsumos', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
'n_id'
|| n_id
||' n_contador: '
||n_contador
||' n_anyo: '
|| n_anyo
||' n_mes: '
||n_mes
||' n_consumo: '
|| n_consumo
, 'rst', rst, rst);
ROLLBACK;
END modificaConsumos;
/
declare
    rst varchar2(250);
begin
--n_id,n_contador, n_anyo,n_mes,n_consumo
modificaConsumos(1,1,2011,1,12, rst);
END;


SELECT * FROM CONSUMOS


