CREATE OR REPLACE
PROCEDURE modificaEmisionCentral(
n_id  IN NUMBER,
n_des IN VARCHAR2,
rst OUT VARCHAR2
)
IS
/******************************************************************************
NOMBRE: modificaEmisionCentral
PROPSITO: gestiona la modificacin  de un tipo de emisin o especificidad de la  Central
PARAMETERS: n_id,n_des, rst
INPUT: n_id,n_des
OUTPUT: rst
RETORNA: 'OK' si la operacin ha tenido sxito, 'ERROR: Tipo de Error' en
caso contrario
EJEMPLO DE USO: modificaEmisionCentral(1,'CO2', rst)
******************************************************************************/
n_des_ins       		VARCHAR2 (50);
id_test			        INTEGER;
des_test        		INTEGER;
err_msg         		VARCHAR2 (100);
dup_id                          EXCEPTION;
dup_ecentral    		EXCEPTION;
desecentral_nulo  	        EXCEPTION;
BEGIN
n_des_ins := SUBSTR (n_des, 1, 50);
--verificamos si el campo ECentral.des es nulo
IF (n_des_ins IS NULL) THEN
RAISE desECentral_nulo;
END IF;
--verificamos que exista el id de estado
SELECT COUNT (*)
INTO id_test
FROM ECentral
WHERE des = n_des_ins;
IF (des_test = 0)
THEN
RAISE dup_id;
END IF;
--verificamos si existe el tipo de estado
SELECT COUNT (*)
INTO des_test
FROM ECentral
WHERE des = n_des_ins;
IF (des_test > 0)
THEN
RAISE dup_ECentral;
END IF;
--modificamos la emisin de la eCentral
UPDATE ecentral
SET
des =	n_des_ins	
WHERE
eCentral.id = n_id;

    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('Modifica ECentral:' 
||' n_id'
||n_id
||' n_des'
|| n_des_ins);
    rst:='Ok, Modifica Tipo ECentral  realizado con xito';
    DBMS_OUTPUT.PUT_LINE('');  
    DBMS_OUTPUT.PUT_LINE(rst); 

--rst := 'OK';
altaLog('Proc. modificaEmisionCentral', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
'Modifica ECentral:'
 ||' n_id'
||n_id
||' n_des'
|| n_des
, 'rst', rst, rst);
COMMIT;

EXCEPTION
WHEN dup_id
THEN
    rst := 'ERROR: No existe este  id de  ECentral';
    DBMS_OUTPUT.PUT_LINE('n_id'||n_id||' n_des'||n_des);  
    DBMS_OUTPUT.PUT_LINE(rst); 
altaLog('Proc. modificaEmisionCentral', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
'Modifica ECentral: '
||' n_id'
||n_id
||' n_des'
|| n_des
, 'rst', rst, rst);
ROLLBACK;
WHEN desECentral_nulo
THEN
    rst := 'ERROR: el tipo de ECentral  no debe ser nulo';
    DBMS_OUTPUT.PUT_LINE('Modifica ECentral:' 
||' n_id'
||n_id
||' n_des'
|| n_des);  
    DBMS_OUTPUT.PUT_LINE(rst);
altaLog('Proc. modificaEmisionCentral', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
'Modifica ECentral:'
||' n_id'
||n_id
||' n_des'
|| n_des
, 'rst', rst, rst);
ROLLBACK;
WHEN dup_ECentral
THEN
    rst := 'ERROR: Ya existe este tipo de  ECentral';
    DBMS_OUTPUT.PUT_LINE('');  
    DBMS_OUTPUT.PUT_LINE(rst); 
altaLog('Proc. modificaEmisionCentral', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
'Modifica ECentral:'
||' n_id'
||n_id
||' n_des'
|| n_des
, 'rst', rst, rst);
ROLLBACK;
WHEN OTHERS
THEN
err_msg := SUBSTR (SQLERRM, 1, 100);
rst := 'ERROR:'
|| err_msg;
altaLog('Proc. modificaEmisionCentral', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
'Modifica ECentral:'
||' n_id'
||n_id
||' n_des'
|| n_des
, 'rst', rst, rst);
ROLLBACK;
END modificaEmisionCentral;
/



