CREATE OR REPLACE
PROCEDURE modificaEstadoCentral(
n_id		IN NUMBER,
n_estado 		IN NUMBER,
rst OUT VARCHAR2
)
IS
/******************************************************************************
NOMBRE: modificaEstadoCentral
PROPSITO: gestiona la modificacin  del estado de  Central
PARAMETERS: n_id,n_estado, rst
INPUT: n_id,n_estado	
OUTPUT: rst
RETORNA: 'OK' si la operacin ha tenido xito, 'ERROR: Tipo de Error' en caso contrario
EJEMPLO DE USO: modificaEstadoCentral(1,2,rst);
******************************************************************************/

id_test				INTEGER;
err_msg 	        		VARCHAR2 (100);
dup_central_id 	           EXCEPTION;
des_nulo  			EXCEPTION;

BEGIN

--verificamos que los campos nulos no sean nulos
IF   		(n_id IS NULL)
	OR 	(n_estado IS NULL)
THEN
RAISE des_nulo;
END IF;


-- verificamos que la Central a modificar exista

SELECT COUNT (*)
INTO id_test
FROM centrales
WHERE centrales.id = n_id;
IF (id_test = 0)
THEN
RAISE dup_central_id;
END IF;


-- modificamos la central cambio de estado
UPDATE centrales
SET
estado 	= n_estado                       
WHERE
centrales.id = n_id;


-- Fin de las operaciones

    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('');
    DBMS_OUTPUT.PUT_LINE('CAMBIO DE ESTADO OK: ' || n_estado); 
    rst:='OK, CAMBIO DE ESTADO CENTRAL ';
    DBMS_OUTPUT.PUT_LINE('');  
    DBMS_OUTPUT.PUT_LINE(rst); 

--rst := 'OK';
altaLog('Proc. modificaEstadoCentral', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
'n_id: '
|| n_id
||' n_estado: '
|| n_estado
, 'rst', rst, rst);
COMMIT;

EXCEPTION
WHEN dup_central_id
THEN
    rst := 'ERROR: NO existe esta  central';
    DBMS_OUTPUT.PUT_LINE('');  
    DBMS_OUTPUT.PUT_LINE(rst); 
altaLog('Proc. modificaEstadoCentral', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
'n_id: '
|| n_id
||' n_estado: '
|| n_estado
, 'rst', rst, rst);
ROLLBACK;

WHEN des_nulo
THEN
    rst := 'ERROR: Hay campos nulos sin contenido';
    DBMS_OUTPUT.PUT_LINE('');  
    DBMS_OUTPUT.PUT_LINE(rst);
altaLog('Proc. modificaEstadoCentral', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
'Proc. modificaEstadoCentral: ' 
|| 'n_id: '
||  n_id
|| ' n_estad0: '
||  n_estado
, 'rst', rst, rst);
ROLLBACK;

WHEN OTHERS
THEN
err_msg := SUBSTR (SQLERRM, 1, 100);
rst := 'ERROR:'
|| err_msg;
altaLog('Proc. modificaEstadoCentral', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
'Proc. modificaEstadoCentral ' || n_id, 'rst', rst, rst);
ROLLBACK;
END modificaEstadoCentral;
/

-- prueba de uso

DECLARE rst VARCHAR2(250);
BEGIN
  modificaestadocentral(2,2, rst);
END;



