CREATE OR REPLACE
PROCEDURE modificaEstados(
n_id  IN NUMBER,
n_des IN VARCHAR2,
rst OUT VARCHAR2
)
IS
/******************************************************************************
NOMBRE: modificaEstados
PROPSITO: gestiona la modificacin de un estado
PARAMETERS: n_id,n_des, rst
INPUT: n_id,n_des
OUTPUT: rst
RETORNA: 'OK' si la operacin ha tenido xito, 'ERROR: Tipo de Error' en caso contrario
EJEMPLO DE USO: modificaEstados('ALTA', rst);
******************************************************************************/
n_des_ins       VARCHAR2 (50);
id_test         INTEGER;
des_test        INTEGER;
err_msg         VARCHAR2 (100);
dup_estados     EXCEPTION;
dup_id          EXCEPTION;
desEstado_nulo  EXCEPTION;

BEGIN
n_des_ins := SUBSTR (n_des, 1, 50);
--verificamos si el campo estados.des es nulo
IF (n_id		 IS NULL)
OR (n_des_ins 	IS NULL)
 THEN
RAISE desEstado_nulo;
END IF;
SELECT COUNT(*)
INTO id_test
FROM estados
WHERE estados.ID = n_id;
IF (id_test = 0)
THEN
RAISE dup_id;
END IF;

--verificamos si existe el tipo de estado
SELECT COUNT (*)
INTO des_test
FROM ESTADOS
WHERE des = n_des_ins;
IF (des_test > 0)
THEN
RAISE dup_estados;
END IF;

-- modificamos la tabla de  ESTADOS
UPDATE estados
SET
id	= n_id,
des  = n_des
WHERE 
estados.id = n_id;

-- Fin de las operaciones

    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('');
    DBMS_OUTPUT.PUT_LINE('Modifica el  tipo de ESTADOS: ' || n_des_ins); 
    rst:='Ok, Modifica Tipo ESTADOS  realizada con exito';
    DBMS_OUTPUT.PUT_LINE('');  
    DBMS_OUTPUT.PUT_LINE(rst); 

--rst := 'OK';
altaLog('Proc. modificaEstados', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
'Tipo de ESTADOS:' || n_des, 'rst', rst, rst);
COMMIT;
EXCEPTION
WHEN dup_id
THEN
    rst := 'ERROR: No existe el id del Estado';
    DBMS_OUTPUT.PUT_LINE('');  
    DBMS_OUTPUT.PUT_LINE(rst); 
altaLog('Proc. modificaEstados', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
'n_id: ' || n_id
, 'rst', rst, rst);
ROLLBACK;

WHEN dup_estados
THEN
    rst := 'ERROR: Ya existe este tipo de  ESTADOS';
    DBMS_OUTPUT.PUT_LINE('');  
    DBMS_OUTPUT.PUT_LINE(rst); 
altaLog('Proc. modificaEstados', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
'Tipo de ESTADOS: ' || n_des, 'rst', rst, rst);
ROLLBACK;
WHEN desEstado_nulo
THEN
    rst := 'ERROR: el tipo de ESTADOS  no debe ser nulo';
    DBMS_OUTPUT.PUT_LINE('');  
    DBMS_OUTPUT.PUT_LINE(rst);
altaLog('Proc. modificaEstados', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
'Tipo de ESTADOS: ' || n_des, 'rst', rst, rst);
ROLLBACK;
WHEN OTHERS
THEN
err_msg := SUBSTR (SQLERRM, 1, 100);
rst := 'ERROR:'
|| err_msg;
altaLog('Proc. modificaEstados', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
'Tipo de ESTADOS: ' || n_des, 'rst', rst, rst);
ROLLBACK;
END modificaEstados;
/

declare
    rst varchar2(250);
begin
--- ESTADOS
modificaEstados(1,'ALTA INICIAL', rst);
end;

select * from LOG
