create or replace PROCEDURE modificaTipoCentral(
n_id			IN NUMBER,
n_des 		IN VARCHAR2,
n_estado 		IN NUMBER,
n_fechaEstado	IN VARCHAR2,
n_emision		IN NUMBER,
n_cantidad		IN NUMBER,
n_obs			IN VARCHAR2,

rst OUT VARCHAR2
)
IS
/******************************************************************************
NOMBRE: modificaTipoCentral
PROPSITO: gestiona la modificacin de un tipo   de Central
PARAMETERS: n_id,n_des,n_estado,n_fechaEstado,n_emision,n_cantidad, n_obs, rst
INPUT: n_id,n_des,n_estado,n_fechaEstado,n_emision,n_cantidad,n_obs	
OUTPUT: rst
RETORNA: 'OK' si la operacin ha tenido xito, 'ERROR: Tipo de Error' en caso contrario
EJEMPLO DE USO: modificaTipoCentral('NUCLEAR',1,'01/05/2012',1,20,NULL,rst);
******************************************************************************/
n_des_ins       		VARCHAR2 (50);
id_test			INTEGER;
des_test        		INTEGER;
err_msg         		VARCHAR2 (100);
dup_id			EXCEPTION;
dup_tcentral    		EXCEPTION;
desTCentral_nulo  	EXCEPTION;
BEGIN
n_des_ins := SUBSTR (n_des, 1, 50);
--verificamos si el campo tcentral.des es nulo
IF ( n_id IS NULL)
OR  (n_des_ins IS NULL) THEN
RAISE desTCentral_nulo;
END IF;

--Verificamos si el codigo del tipo  de central existe
SELECT COUNT (*)
INTO id_test
FROM tcentral
WHERE ID = n_id;
IF (id_test = 0)
THEN
RAISE dup_id;
END IF;
--verificamos si existe el tipo de estado
SELECT COUNT (*)
INTO des_test
FROM tcentral
WHERE des = n_des_ins;
IF (des_test > 0)
THEN
RAISE dup_tcentral;
END IF;
-- insertamos el nuevo tipo de tcentral
INSERT INTO tcentral
(des,estado,fechaEstado,emision,cantidad,obs)
VALUES
(n_des_ins,n_estado,n_fechaEstado,n_emision,n_cantidad,n_obs);


-- Fin de las operaciones

    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('');
    DBMS_OUTPUT.PUT_LINE('Modifica  de tipo de tcentral: ' || n_des_ins); 
    rst:='Ok, Modifica  Tipo tcentral  realizada con exito';
    DBMS_OUTPUT.PUT_LINE('');  
    DBMS_OUTPUT.PUT_LINE(rst); 

--rst := 'OK';
altaLog('Proc. modificaTipoCentral', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
'Tipo de tcentral:' || n_des, 'rst', rst, rst);
COMMIT;
EXCEPTION

WHEN dup_id
THEN
    rst := 'ERROR: No existe este cdigo de tipo de central';
    DBMS_OUTPUT.PUT_LINE('');  
    DBMS_OUTPUT.PUT_LINE(rst); 
altaLog('Proc. modificaClaseCentral', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
'Tipo de CCENTRAL: ' || n_des
, 'rst', rst, rst);
ROLLBACK;

WHEN dup_tcentral
THEN
    rst := 'ERROR: Ya existe este tipo de  tcentral';
    DBMS_OUTPUT.PUT_LINE('');  
    DBMS_OUTPUT.PUT_LINE(rst); 
altaLog('Proc. modificaTipoCentral', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
'Tipo de tcentral: ' || n_des, 'rst', rst, rst);
ROLLBACK;
WHEN desTCentral_nulo
THEN
    rst := 'ERROR: el tipo de tcentral  no debe ser nulo';
    DBMS_OUTPUT.PUT_LINE('');  
    DBMS_OUTPUT.PUT_LINE(rst);
altaLog('Proc. modificaTipoCentral', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
'Tipo de tcentral: ' || n_des, 'rst', rst, rst);
ROLLBACK;
WHEN OTHERS
THEN
err_msg := SUBSTR (SQLERRM, 1, 100);
rst := 'ERROR:'
|| err_msg;
altaLog('Proc. modificaTipoCentral', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
'Tipo de tcentral: ' || n_des, 'rst', rst, rst);
ROLLBACK;
END modificaTipoCentral;
/



