create or replace PROCEDURE modificaTipoCliente(
n_id  IN VARCHAR2,
n_des IN VARCHAR2,
rst OUT VARCHAR2
)
IS
/******************************************************************************
NOMBRE: modificaTipoCliente
PROPSITO: gestiona la modificacin de un tipo de cliente
PARAMETERS: n_id,n_des, rst
INPUT: n_id,n_des
OUTPUT: rst
RETORNA: 'OK' si la operacin ha sido exitosa, 'ERROR: Tipo de Error' en caso contrario
EJEMPLO DE USO: modificaTipoCliente('PARTICULAR', rst);
******************************************************************************/
n_des_ins       VARCHAR2 (50);
id_test		INTEGER;
des_test        INTEGER;
err_msg         VARCHAR2 (100);
dup_id		EXCEPTION;
dup_des      EXCEPTION;
des_nulo      EXCEPTION;
BEGIN
n_des_ins := SUBSTR (n_des, 1, 50);
--verificamos si el campo tCliente.des es nulo
IF (n_des_ins IS NULL) THEN
RAISE des_nulo;
END IF;


--comprobar que existe el id a modificar
SELECT COUNT (*)
INTO id_test
FROM tcliente
WHERE tcliente.ID = n_id;
IF (id_test = 0)
THEN
RAISE dup_id;
END IF;

--verificamos si existe el tipo de Cliente
SELECT COUNT (*)
INTO des_test
FROM tCliente
WHERE des = n_des_ins;
IF (des_test > 0)
THEN
RAISE dup_des;
END IF;


-- modificacmos el tipo de Cliente
UPDATE tcliente
SET
des = n_des_ins
WHERE
tcliente.id = n_id;
-- Fin de las operaciones

    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('');
    DBMS_OUTPUT.PUT_LINE('Modifica  de tipo de Cliente: ' || n_id); 
    rst:='Ok, Modifica Tipo Cliente  realizado con exito';
    DBMS_OUTPUT.PUT_LINE('');  
    DBMS_OUTPUT.PUT_LINE(rst); 
--rst := 'OK';
altaLog('Proc. modificaTipoCliente', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
'Tipo de Cliente:' || n_des, 'rst', rst, rst);
COMMIT;
EXCEPTION

WHEN dup_id
THEN
  DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('');
    DBMS_OUTPUT.PUT_LINE('n_id : ' || n_id  ); 
     rst := 'ERROR: NO existe el tipo de Cliente';
    DBMS_OUTPUT.PUT_LINE('');  
    DBMS_OUTPUT.PUT_LINE(rst);

rst := 'ERROR: No existe el  CODIGO DEL tipo de cliente ';
altaLog('Proc. modificaClientes', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
'n_id : ' || n_id 
, 'rst', rst, rst);
ROLLBACK;

WHEN dup_des
THEN
    rst := 'ERROR: Ya existe esta descripcin del  tipo de  Cliente';
    DBMS_OUTPUT.PUT_LINE('');  
    DBMS_OUTPUT.PUT_LINE(rst); 
altaLog('Proc. modificaTipoCliente', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
'Tipo de Cliente: ' || n_des, 'rst', rst, rst);
ROLLBACK;
WHEN des_nulo
THEN
    rst := 'ERROR: el tipo de Cliente  no debe ser nulo';
    DBMS_OUTPUT.PUT_LINE('');  
    DBMS_OUTPUT.PUT_LINE(rst);
altaLog('Proc. modificaTipoCliente', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
'Tipo de Cliente: ' || n_des, 'rst', rst, rst);
ROLLBACK;
WHEN OTHERS
THEN
err_msg := SUBSTR (SQLERRM, 1, 100);
rst := 'ERROR:'
|| err_msg;
altaLog('Proc. modificaTipoCliente', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
'Tipo de Cliente: ' || n_des, 'rst', rst, rst);
ROLLBACK;
END modificaTipoCliente;
/

INSERT INTO tCliente(des) VALUES ('FUNCIONARIO');
-- prueba de uso

DECLARE rst VARCHAR2(250);
BEGIN
modificaTipoCliente(1,'PARTICULARis', rst);
END;

