create or replace PROCEDURE modificaVia(
n_id    IN NUMBER,
n_des   IN VARCHAR2,
rst     OUT VARCHAR2
)
IS
/******************************************************************************
NOMBRE: modificaVia
PROPSITO: gestiona la modificacin  de una via
PARAMETERS: n_id,n_des, rst
INPUT: n_id, n_des
OUTPUT: rst
RETORNA: 'OK' si la operacin ha tenido xito, 'ERROR: Tipo de Error' en caso contrario
EJEMPLO DE USO: modificaVia(1,'Rambla', rst);
******************************************************************************/
n_des_ins       VARCHAR2 (50);
id_test        INTEGER;
des_test        INTEGER;
err_msg         VARCHAR2 (100);
dup_idVia       EXCEPTION;
desVia_nulo      EXCEPTION;
BEGIN
n_des_ins := SUBSTR (n_des, 1, 50);
--verificamos campos nulos
IF ( n_id  IS NULL)
OR (n_des_ins IS NULL) THEN
RAISE desVia_nulo;
END IF;
--verificamos si existe la via
SELECT COUNT (*)
INTO id_test
FROM VIA
WHERE via.id  = n_id;
IF (id_test = 0)
THEN
RAISE dup_idVia;
END IF;


-- modificamos la via
UPDATE via
SET
via.des = n_des_ins
where
via.id = n_id; 

-- Fin de las operaciones

    DBMS_OUTPUT.ENABLE;
    DBMS_OUTPUT.PUT_LINE('');
    DBMS_OUTPUT.PUT_LINE('Modificacin via: ' || n_id); 
    rst:='Ok, Modificacin Via ';
    DBMS_OUTPUT.PUT_LINE('');  
    DBMS_OUTPUT.PUT_LINE(rst); 

--rst := 'OK';
altaLog('Proc. modificaVia', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
'Tipo de Via:' || n_des, 'rst', rst, rst);
COMMIT;
EXCEPTION
WHEN dup_idVia
THEN
    rst := 'ERROR: No existe esta Via';
    DBMS_OUTPUT.PUT_LINE('');  
    DBMS_OUTPUT.PUT_LINE(rst); 
altaLog('Proc. modificaVia', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
'Tipo de Via: ' || n_id, 'rst', rst, rst);
ROLLBACK;


WHEN desVia_nulo
THEN
    rst := 'ERROR: el tipo de via  no debe ser nulo';
    DBMS_OUTPUT.PUT_LINE('');  
    DBMS_OUTPUT.PUT_LINE(rst);
altaLog('Proc. modificaVia', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
'Tipo de Via: ' || n_des, 'rst', rst, rst);
ROLLBACK;
WHEN OTHERS
THEN
err_msg := SUBSTR (SQLERRM, 1, 100);
rst := 'ERROR:'
|| err_msg;
altaLog('Proc. modificaVia', to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'),
'Tipo de Via: ' || n_des, 'rst', rst, rst);
ROLLBACK;
END modificaVia;
/



