
/******************************************************************************
NOMBRE:   INICIALIZAR CONSULTAS
          BORRAMOS LAS TABLAS
          CREAMOS TABLAS  CON LAS SECUENCIAS Y DISPARADORES
******************************************************************************/

--CONSULTAS
drop table C1   cascade constraint purge;
drop table C2   cascade constraint purge;
drop table C3   cascade constraint purge;
drop table C4   cascade constraint purge;
drop table C5   cascade constraint purge;
drop table C6   cascade constraint purge;
drop table C7   cascade constraint purge;

drop sequence C1_SEQ_GRAL;
drop sequence C2_SEQ_GRAL;
drop sequence C3_SEQ_GRAL;
drop sequence C4_SEQ_GRAL;
drop sequence C5_SEQ_GRAL;
drop sequence C6_SEQ_GRAL;
drop sequence C7_SEQ_GRAL;


-------------
--CONSULTAS
------------
--CONSULTA 1  a
CREATE TABLE C1     --consultarCiudadFecha 
(
 ID                   NUMBER             CONSTRAINT      PK_C1                                           PRIMARY KEY,
 contrato             NUMBER             CONSTRAINT      FK_C1_contrato    REFERENCES   contratos(ID)     NOT NULL, 
 pContratada          NUMBER(9,2)        CONSTRAINT      NN_C1_pContratada                                NOT NULL, 
 tpConsumo            NUMBER(9,2)        CONSTRAINT      NN_C1_tpConsumo                                  NOT NULL,
 mConsumo             NUMBER(9,2)        CONSTRAINT      NN_C1_mConsumo                                   NOT NULL,
 anyo                 NUMBER             CONSTRAINT      NN_C1_anyo          NOT NULL,
 mes                  NUMBER             CONSTRAINT      NN_C1_mes           NOT NULL
 --fecha                VARCHAR2(11 CHAR)   CONSTRAINT     NN_C1_pInicial                                   NOT NULL
);

--CONSULTA 2   b
CREATE TABLE C2     --consultarCentralesDistribucionMasEnergia 
(
 ID                   NUMBER             CONSTRAINT      PK_C2                                            PRIMARY KEY,
 central              NUMBER             CONSTRAINT      FK_C2_central     REFERENCES   centrales(ID)     NOT NULL, 
 ubica                NUMBER             CONSTRAINT      NN_C2_ubica                                      NOT NULL, 
 eEmitida             NUMBER(9,2)        CONSTRAINT      NN_C2_eEmitida                                   NOT NULL,
 eMax                 NUMBER(9,2)        CONSTRAINT      NN_C2_eMax                                       NOT NULL
);

--CONSULTA 3    c
CREATE TABLE C3     --consultarLineasMasCargadasCapacidadMaxima 
(
 ID                   NUMBER             CONSTRAINT      PK_C3                                            PRIMARY KEY,
 linea                NUMBER             CONSTRAINT      FK_C3_linea     REFERENCES   lineas(ID)          NOT NULL, 
 cLinea               NUMBER(9,2)        CONSTRAINT      NN_C3_cLinea                                     NOT NULL, 
 eAmplia              NUMBER(9,2)        CONSTRAINT      NN_C3_eAmplia                                    NOT NULL
);

--CONSULTA 4   d
CREATE TABLE C4     --consultarClientesContadoresAltaDisponibiliad 
(
 ID                   NUMBER             CONSTRAINT      PK_C4                                            PRIMARY KEY,
 dni                  VARCHAR2(10 CHAR)  CONSTRAINT      NN_C4_dni                                        NOT NULL, 
 contrato             NUMBER             CONSTRAINT      FK1_C4_contrato    REFERENCES   contratos(ID)    NOT NULL, 
 modelo               NUMBER             CONSTRAINT      FK2_C4_modelo      REFERENCES   modelos(ID)      NOT NULL
);

--CONSULTA 5 e
CREATE TABLE C5     --consultarConsumoContadoresCentralIntervaloTiempo 
(
 ID                   NUMBER             CONSTRAINT      PK_C5                                               PRIMARY KEY,
 central              NUMBER             CONSTRAINT      FK_C5_central      REFERENCES    centrales(ID)       NOT NULL, 
 contador             NUMBER              CONSTRAINT      NN_C5_contador     REFERENCES    contadores(ID)      NOT NULL, 
 consumo              NUMBER(9,2)        CONSTRAINT      NN_C5_consumo                                        NOT NULL,
 eProd                NUMBER(9,2)        CONSTRAINT      NN_C5_eProd                                          NOT NULL,
 pInicial             VARCHAR2(11 CHAR)   CONSTRAINT     NN_C5_pInicial                                      NOT NULL,
 pFinal               VARCHAR2(11 CHAR)   CONSTRAINT     NN_C5_pFinal                                        NOT NULL
);

--CONSULTA 6 f
CREATE TABLE C6     --consultarPercentLecturasPresencialTelematica 
(
 ID                   NUMBER             CONSTRAINT       PK_C6                                               PRIMARY KEY,
 telematica           NUMBER             CONSTRAINT       FK1_C6_telematica     REFERENCES    tLectura(ID)    NOT NULL, 
 presencial           NUMBER             CONSTRAINT       FK2_C6_presencial     REFERENCES    tLectura(ID)    NOT NULL, 
 pTelematica          NUMBER(9,2)        CONSTRAINT       NN_C6_pTelematica                                   NOT NULL,
 pPresencial          NUMBER(9,2)        CONSTRAINT       NN_C6_pPresencial                                   NOT NULL,
 total                NUMBER(9,2)        CONSTRAINT       NN_C6_total                                         NOT NULL,
 pInicial             VARCHAR2(11 CHAR)   CONSTRAINT      NN_C6_pInicial                                      NOT NULL,
 pFinal               VARCHAR2(11 CHAR)   CONSTRAINT      NN_C6_pFinal                                        NOT NULL
);

--CONSULTA 7 g
CREATE TABLE C7     --consultarContadoresAntiguedad 
(
 ID                   NUMBER             CONSTRAINT      PK_C7                                               PRIMARY KEY,
 contador             NUMBER             CONSTRAINT      FK1_C7_contador    REFERENCES    contadores(ID)     NOT NULL, 
 anyos                NUMBER             CONSTRAINT      NN_C7_anyos                                         NOT NULL,
 fabrica              VARCHAR2(4 CHAR)   CONSTRAINT      NN_C7_fabrica                                       NOT NULL,
 fechaConsulta        DATE  
);


--------------------------
--CONULTAS
CREATE SEQUENCE C1_SEQ_GRAL  START WITH 1  INCREMENT BY 1  NOMAXVALUE  NOCACHE;
CREATE SEQUENCE C2_SEQ_GRAL  START WITH 1  INCREMENT BY 1  NOMAXVALUE  NOCACHE;
CREATE SEQUENCE C3_SEQ_GRAL  START WITH 1  INCREMENT BY 1  NOMAXVALUE  NOCACHE;
CREATE SEQUENCE C4_SEQ_GRAL  START WITH 1  INCREMENT BY 1  NOMAXVALUE  NOCACHE;
CREATE SEQUENCE C5_SEQ_GRAL  START WITH 1  INCREMENT BY 1  NOMAXVALUE  NOCACHE;
CREATE SEQUENCE C6_SEQ_GRAL  START WITH 1  INCREMENT BY 1  NOMAXVALUE  NOCACHE;
CREATE SEQUENCE C7_SEQ_GRAL  START WITH 1  INCREMENT BY 1  NOMAXVALUE  NOCACHE;

----------CONSULTAS

CREATE OR REPLACE TRIGGER  C1_TR_KEY  BEFORE INSERT  ON  C1   FOR EACH ROW
    BEGIN          SELECT  C1_SEQ_GRAL.NEXTVAL INTO :NEW.id FROM dual;
    END;
/
CREATE OR REPLACE TRIGGER  C2_TR_KEY  BEFORE INSERT  ON  C2   FOR EACH ROW
    BEGIN          SELECT  C2_SEQ_GRAL.NEXTVAL INTO :NEW.id FROM dual;
    END;
/
CREATE OR REPLACE TRIGGER  C3_TR_KEY  BEFORE INSERT  ON  C3   FOR EACH ROW
    BEGIN          SELECT  C3_SEQ_GRAL.NEXTVAL INTO :NEW.id FROM dual;
    END;
/
CREATE OR REPLACE TRIGGER  C4_TR_KEY  BEFORE INSERT  ON  C4   FOR EACH ROW
    BEGIN          SELECT  C4_SEQ_GRAL.NEXTVAL INTO :NEW.id FROM dual;
    END;
/
CREATE OR REPLACE TRIGGER  C5_TR_KEY  BEFORE INSERT  ON  C5   FOR EACH ROW
    BEGIN          SELECT  C5_SEQ_GRAL.NEXTVAL INTO :NEW.id FROM dual;
    END;
/
CREATE OR REPLACE TRIGGER  C6_TR_KEY  BEFORE INSERT  ON  C6   FOR EACH ROW
    BEGIN          SELECT  C6_SEQ_GRAL.NEXTVAL INTO :NEW.id FROM dual;
    END;
/
CREATE OR REPLACE TRIGGER  C7_TR_KEY  BEFORE INSERT  ON  C7   FOR EACH ROW
    BEGIN          SELECT  C7_SEQ_GRAL.NEXTVAL INTO :NEW.id FROM dual;
    END;
