/******************************************************************************
NOMBRE:   INICIALIZAR ESTADSTICAS
          BORRAMOS LAS TABLAS
          CREAMOS TABLAS  CON LAS SECUENCIAS Y DISPARADORES
******************************************************************************/
--ESTADISTICAS
drop table E_1             cascade constraint purge;
drop table E_2             cascade constraint purge;
drop table E_3             cascade constraint purge;
drop table E_4             cascade constraint purge;
drop table E_5             cascade constraint purge;
drop table E_6             cascade constraint purge;
drop table E_7             cascade constraint purge;

drop sequence e_1_SEQ_GRAL;
drop sequence e_2_SEQ_GRAL;
drop sequence e_3_SEQ_GRAL;
drop sequence e_4_SEQ_GRAL;
drop sequence e_5_SEQ_GRAL;
drop sequence e_6_SEQ_GRAL;
drop sequence e_7_SEQ_GRAL;





CREATE TABLE E_1 --Donada una central de producci, el consum dels comptadors que depenen de la central.
(
 ID                   NUMBER          CONSTRAINT        PK_e_1                                             PRIMARY KEY,
 central                              CONSTRAINT        FK_e_1_central           REFERENCES centrales(ID)  NOT NULL,
 consumoContadores    NUMBER(9,2)     CONSTRAINT        NN_e_1_consumoContadores                           NOT NULL,
  fecha                VARCHAR2(11 CHAR)   CONSTRAINT   NN_e_1_fecha                                       NOT NULL
);

CREATE TABLE E_2   --consumo de energia media de una linea en un ao                  
(
 ID                   NUMBER             CONSTRAINT      PK_e_2                                PRIMARY KEY,
 linea                                   CONSTRAINT      FK_e_2_linea     REFERENCES  linea(ID) NOT NULL,
 anyo                 NUMBER             CONSTRAINT      NN_e_2_anyo                           NOT NULL, 
 consumoEnergiaMedio  NUMBER(9,2)        CONSTRAINT      NN_e_2_consumoEnergiaMedio            NOT NULL
);

CREATE TABLE E_3   -- E3_Lnia que ha estado ms cargada a nivel de energa consumida.
(
 ID                   NUMBER             CONSTRAINT      PK_e_3                                PRIMARY KEY,
 linea                                   CONSTRAINT      FK_e_3_linea    REFERENCES  linea(ID) NOT NULL,
 consumoContadores    NUMBER(9,2)        CONSTRAINT      NN_e_3_consumoContadores              NOT NULL,
 fecha                VARCHAR2(11 CHAR)   CONSTRAINT     NN_e_3_fecha                          NOT NULL
);

CREATE TABLE E_4    -- E4 Dado un ao concreto porcentaje de lineas que superan el el 50% de energa consumida.
(
 ID                   NUMBER             CONSTRAINT      PK_e_4                                PRIMARY KEY,
 anyo                 NUMBER             CONSTRAINT      NN_e_4_anyo                           NOT NULL, 
 perLineaMas50        NUMBER(9,2)        CONSTRAINT      NN_e_4_perLineaMas50                  NOT NULL
);

CREATE TABLE E_5    -- E5 Dado un ao en concreto: el numero de centrales de produccin que generan menos del  30% de produccin.
(
 ID                       NUMBER             CONSTRAINT      PK_e_5                                    PRIMARY KEY,
 anyo                     NUMBER             CONSTRAINT      NN_e_5_anyo                               NOT NULL, 
 cenProduccionMenos30     NUMBER(9,2)        CONSTRAINT      NN_e_5_cenProduccionMenos30               NOT NULL
);

CREATE TABLE E_6    -- E6 Top-10 de contadores que histricamente han tenido ms consumo.
(
 ID                     NUMBER             CONSTRAINT      PK_e_6                                         PRIMARY KEY,
 contador                                  CONSTRAINT      FK_e_6_contador   REFERENCES  contadores(ID)   NOT NULL,
 consumo                NUMBER(9,2)        CONSTRAINT      NN_e_6_consumo                                 NOT NULL
);

CREATE TABLE E_7    -- E7 Consumo medio de todos los clientes.
(
 ID                     NUMBER              CONSTRAINT      PK_e_7                                          PRIMARY KEY,
 cliente                                    CONSTRAINT      FK_e_7_cliente       REFERENCES  clientes(ID)   NOT NULL,
 consumoMedio           NUMBER(9,2)         CONSTRAINT      NN_e7_consumoMedio                              NOT NULL
);

CREATE SEQUENCE e_1_SEQ_GRAL     START WITH 1  INCREMENT BY 1  NOMAXVALUE  NOCACHE;
CREATE SEQUENCE e_2_SEQ_GRAL 	 START WITH 1  INCREMENT BY 1  NOMAXVALUE  NOCACHE;
CREATE SEQUENCE e_3_SEQ_GRAL     START WITH 1  INCREMENT BY 1  NOMAXVALUE  NOCACHE;
CREATE SEQUENCE e_4_SEQ_GRAL 	 START WITH 1  INCREMENT BY 1  NOMAXVALUE  NOCACHE;
CREATE SEQUENCE e_5_SEQ_GRAL     START WITH 1  INCREMENT BY 1  NOMAXVALUE  NOCACHE;
CREATE SEQUENCE e_6_SEQ_GRAL 	 START WITH 1  INCREMENT BY 1  NOMAXVALUE  NOCACHE;
CREATE SEQUENCE e_7_SEQ_GRAL 	 START WITH 1  INCREMENT BY 1  NOMAXVALUE  NOCACHE;

---------------ESTADISTICAS-------
----------------------------------
CREATE OR REPLACE TRIGGER           e_1_TR_KEY
        BEFORE INSERT        ON     e_1   FOR EACH ROW
    BEGIN                   SELECT  e_1_SEQ_GRAL.NEXTVAL INTO :NEW.id FROM dual;
    END;
/
CREATE OR REPLACE TRIGGER           e_2_TR_KEY
        BEFORE INSERT        ON     e_2   FOR EACH ROW
    BEGIN                   SELECT  e_2_SEQ_GRAL.NEXTVAL INTO :NEW.id FROM dual;
    END;
/
CREATE OR REPLACE TRIGGER           e_3_TR_KEY
        BEFORE INSERT        ON     e_3   FOR EACH ROW
    BEGIN                   SELECT  e_3_SEQ_GRAL.NEXTVAL INTO :NEW.id FROM dual;
    END;
/
CREATE OR REPLACE TRIGGER           e_4_TR_KEY
        BEFORE INSERT        ON     e_4   FOR EACH ROW
    BEGIN                   SELECT  e_4_SEQ_GRAL.NEXTVAL INTO :NEW.id FROM dual;
    END;
/
CREATE OR REPLACE TRIGGER           e_5_TR_KEY
        BEFORE INSERT        ON     e_5   FOR EACH ROW
    BEGIN                   SELECT  e_5_SEQ_GRAL.NEXTVAL INTO :NEW.id FROM dual;
    END;
/
CREATE OR REPLACE TRIGGER           e_6_TR_KEY
        BEFORE INSERT        ON     e_6   FOR EACH ROW
    BEGIN                   SELECT  e_6_SEQ_GRAL.NEXTVAL INTO :NEW.id FROM dual;
    END;
/
CREATE OR REPLACE TRIGGER           e_7_TR_KEY
        BEFORE INSERT        ON     e_7   FOR EACH ROW
    BEGIN                   SELECT  e_7_SEQ_GRAL.NEXTVAL INTO :NEW.id FROM dual;
    END;


