/*
drop table contratos      cascade constraint purge;
drop table lecturas       cascade constraint purge;
drop table consumos       cascade constraint purge;
*/

-------------------------------------
-------       CONTRATOS  
drop table    contratos            cascade constraint purge;
CREATE TABLE  contratos  
(
 ID             NUMBER        CONSTRAINT PK_contratos             PRIMARY KEY,
 cliente                      CONSTRAINT FK1_contratos_cliente    REFERENCES  clientes(ID)    NOT NULL,
 contador                     CONSTRAINT FK2_contratos_contador   REFERENCES  contadores(ID)  NOT NULL,
 estado                       CONSTRAINT FK3_contratos_estado     REFERENCES  estados(ID)     NOT NULL,
 fechaEstado    DATE          CONSTRAINT NN_contratos_fechaEstado                             NOT NULL,
 pContrato      NUMBER (9,2)  CONSTRAINT NN_contratos_pContrato                               NOT NULL,
 obs            VARCHAR(50 CHAR)         NULL
);
drop  SEQUENCE              contratos_SEQ_GRAL;
CREATE  SEQUENCE            contratos_SEQ_GRAL   START WITH 1    INCREMENT BY 1  NOMAXVALUE  NOCACHE;
CREATE OR REPLACE TRIGGER   contratos_TR_KEY
    BEFORE INSERT    ON     contratos
    FOR EACH ROW
   BEGIN      SELECT        contratos_SEQ_GRAL.NEXTVAL INTO :NEW.id FROM dual;
END;
/

--            LECTURAS
drop table    lecturas            cascade constraint purge;
CREATE TABLE  lecturas 
(
 ID               NUMBER            CONSTRAINT      PK_lecturas                   PRIMARY KEY,
 contador                           CONSTRAINT      FK1_lecturas_contador         REFERENCES  contadores(ID)  NOT NULL, 
 fechaLectura     DATE              CONSTRAINT      NN_lecturas_fechaLectura                                  NOT NULL,
 tipo                               CONSTRAINT      FK2_lecturas_tipo             REFERENCES  tLectura(ID)    NOT NULL, 
 anterior         NUMBER(9,2)       NULL,
 actual           NUMBER(9,2)       NULL,
 consumo          NUMBER(9,2)       CONSTRAINT      NN_lecturas_consumo           NOT NULL              
);
drop sequence               lecturas_SEQ_GRAL;
CREATE  SEQUENCE            lecturas_SEQ_GRAL    START WITH 1    INCREMENT BY 1  NOMAXVALUE  NOCACHE;
CREATE OR REPLACE TRIGGER   lecturas_TR_KEY
    BEFORE INSERT      ON   lecturas
    FOR EACH ROW
   BEGIN
      SELECT                lecturas_SEQ_GRAL.NEXTVAL INTO :NEW.id FROM dual;
END;
/
--            CONSUMOS
drop table consumos       cascade constraint purge;
CREATE TABLE consumos 
(
 ID             NUMBER          CONSTRAINT      PK_consumos               PRIMARY KEY,
 contador                       CONSTRAINT      FK_consumos_contador      REFERENCES contadores(ID) NOT NULL, 
 anyo     NUMBER  CONSTRAINT      NN_consumos_anyo          NOT NULL,
 mes      NUMBER  CONSTRAINT      NN_consumos_mes           NOT NULL,
 consumo       NUMBER(9,2)        --CONSTRAINT NN_consumos_consumo        
);
DROP  SEQUENCE                          consumos_SEQ_GRAL;
CREATE  SEQUENCE                        consumos_SEQ_GRAL    START WITH 1    INCREMENT BY 1  NOMAXVALUE  NOCACHE;
CREATE OR REPLACE TRIGGER               consumos_TR_KEY
    BEFORE INSERT      ON               consumos
    FOR EACH ROW   BEGIN      SELECT    consumos_SEQ_GRAL.NEXTVAL INTO :NEW.id FROM dual;
END;
/
--------------------------------------------
declare
    rst varchar2(250);
begin
--          n_cliente, n_contador, n_estado, n_fechaEstado, n_pContrato, n_obs
altaContratos(1,1,1,'01/01/2011',4000,'obs_cliente_1',rst);
altaContratos(2,2,1,'01/01/2011',4000,'obs_cliente_2',rst);
altaContratos(3,3,1,'01/01/2011',4000,'obs_cliente_3',rst);
altaContratos(4,4,1,'01/01/2011',4000,'obs_cliente_4',rst);
altaContratos(5,5,1,'01/01/2011',4000,'obs_cliente_5',rst);
altaContratos(6,6,1,'01/01/2011',4000,'obs_cliente_6',rst);
altaContratos(7,7,1,'01/01/2011',4000,'obs_cliente_7',rst);
altaContratos(8,8,1,'01/01/2011',4000,'obs_cliente_8',rst);
altaContratos(9,9,1,'01/01/2011',4000,'obs_cliente_9',rst);
altaContratos(10,10,1,'01/01/2011',4000,'obs_cliente_10',rst);
altaContratos(11,11,1,'01/02/2012',4000,'obs_cliente_11',rst);
altaContratos(12,12,1,'01/03/2012',4000,'obs_cliente_12',rst);
altaContratos(13,13,1,'01/04/2012',4000,'obs_cliente_13',rst);
altaContratos(14,14,1,'01/05/2012',4000,'obs_cliente_14',rst);
altaContratos(15,15,1,'01/06/2012',4000,'obs_cliente_15',rst);
altaContratos(16,16,1,'01/07/2012',4000,'obs_cliente_16',rst);
altaContratos(17,17,1,'01/08/2012',4000,'obs_cliente_17',rst);
altaContratos(18,18,1,'01/09/2012',4000,'obs_cliente_18',rst);
altaContratos(19,19,1,'01/10/2012',4000,'obs_cliente_19',rst);
altaContratos(20,20,1,'01/11/2012',4000,'obs_cliente_20',rst);
end;
/
declare
    rst varchar2(250);
begin
--          n_contador, n_fechaLectura,n_tipo,n_lectura
altaLectura(1,'01/01/2011',1,100,rst);
altaLectura(1,'01/02/2011',1,120,rst);
altaLectura(1,'01/03/2011',1,130,rst);
altaLectura(1,'01/04/2011',1,140,rst);
altaLectura(1,'01/05/2011',1,150,rst);
altaLectura(1,'01/06/2011',1,160,rst);
altaLectura(1,'01/07/2011',1,170,rst);
altaLectura(1,'01/08/2011',1,180,rst);
altaLectura(1,'01/09/2011',1,190,rst);
altaLectura(1,'01/10/2011',1,200,rst);
altaLectura(1,'01/11/2011',1,220,rst);
altaLectura(1,'01/12/2011',1,300,rst);
altaLectura(2,'01/01/2011',1,10,rst);
altaLectura(2,'01/02/2011',1,20,rst);
altaLectura(2,'01/03/2011',1,30,rst);
altaLectura(2,'01/04/2011',1,40,rst);
altaLectura(2,'01/05/2011',1,50,rst);
altaLectura(2,'01/06/2011',1,60,rst);
altaLectura(2,'01/07/2011',1,70,rst);
altaLectura(2,'01/08/2011',1,80,rst);
altaLectura(2,'01/09/2011',1,90,rst);
altaLectura(2,'01/10/2011',1,100,rst);
altaLectura(2,'01/11/2011',1,110,rst);
altaLectura(2,'01/12/2011',1,120,rst);
altaLectura(3,'01/01/2011',1,30,rst);
altaLectura(3,'01/02/2011',1,31,rst);
altaLectura(3,'01/03/2011',1,32,rst);
altaLectura(3,'01/04/2011',1,33,rst);
altaLectura(3,'01/05/2011',1,34,rst);
altaLectura(3,'01/06/2011',1,35,rst);
altaLectura(3,'01/07/2011',1,36,rst);
altaLectura(3,'01/08/2011',1,37,rst);
altaLectura(3,'01/09/2011',1,38,rst);
altaLectura(3,'01/10/2011',1,39,rst);
altaLectura(3,'01/11/2011',1,40,rst);
altaLectura(3,'01/12/2011',1,41,rst);
altaLectura(4,'01/01/2011',1,40,rst);
altaLectura(4,'01/02/2011',1,41,rst);
altaLectura(4,'01/03/2011',1,42,rst);
altaLectura(4,'01/04/2011',1,43,rst);
altaLectura(4,'01/05/2011',1,44,rst);
altaLectura(4,'01/06/2011',1,45,rst);
altaLectura(4,'01/07/2011',1,46,rst);
altaLectura(4,'01/08/2011',1,47,rst);
altaLectura(4,'01/09/2011',1,48,rst);
altaLectura(4,'01/10/2011',1,49,rst);
altaLectura(4,'01/11/2011',1,50,rst);
altaLectura(4,'01/12/2011',1,51,rst);
altaLectura(5,'01/01/2011',1,50,rst);
altaLectura(5,'01/02/2011',1,51,rst);
altaLectura(5,'01/03/2011',1,52,rst);
altaLectura(5,'01/04/2011',1,53,rst);
altaLectura(5,'01/05/2011',1,54,rst);
altaLectura(5,'01/06/2011',1,55,rst);
altaLectura(5,'01/07/2011',1,56,rst);
altaLectura(5,'01/08/2011',1,57,rst);
altaLectura(5,'01/09/2011',1,58,rst);
altaLectura(5,'01/10/2011',1,59,rst);
altaLectura(5,'01/11/2011',1,60,rst);
altaLectura(5,'01/12/2011',1,61,rst);
altaLectura(6,'01/01/2011',1,70,rst);
altaLectura(6,'01/02/2011',1,71,rst);
altaLectura(6,'01/03/2011',1,72,rst);
altaLectura(6,'01/04/2011',1,73,rst);
altaLectura(6,'01/05/2011',1,74,rst);
altaLectura(6,'01/06/2011',1,75,rst);
altaLectura(6,'01/07/2011',1,76,rst);
altaLectura(6,'01/08/2011',1,77,rst);
altaLectura(6,'01/09/2011',1,78,rst);
altaLectura(6,'01/10/2011',1,79,rst);
altaLectura(6,'01/11/2011',1,80,rst);
altaLectura(6,'01/12/2011',1,81,rst);
altaLectura(7,'01/01/2011',1,170,rst);
altaLectura(7,'01/02/2011',1,171,rst);
altaLectura(7,'01/03/2011',1,172,rst);
altaLectura(7,'01/04/2011',1,173,rst);
altaLectura(7,'01/05/2011',1,174,rst);
altaLectura(7,'01/06/2011',1,175,rst);
altaLectura(7,'01/07/2011',1,176,rst);
altaLectura(7,'01/08/2011',1,177,rst);
altaLectura(7,'01/09/2011',1,178,rst);
altaLectura(7,'01/10/2011',1,179,rst);
altaLectura(7,'01/11/2011',1,180,rst);
altaLectura(7,'01/12/2011',1,181,rst);
altaLectura(8,'01/01/2011',1,180,rst);
altaLectura(8,'01/02/2011',1,181,rst);
altaLectura(8,'01/03/2011',1,182,rst);
altaLectura(8,'01/04/2011',1,183,rst);
altaLectura(8,'01/05/2011',1,184,rst);
altaLectura(8,'01/06/2011',1,185,rst);
altaLectura(8,'01/07/2011',1,186,rst);
altaLectura(8,'01/08/2011',1,187,rst);
altaLectura(8,'01/09/2011',1,188,rst);
altaLectura(8,'01/10/2011',1,189,rst);
altaLectura(8,'01/11/2011',1,190,rst);
altaLectura(8,'01/12/2011',1,191,rst);
altaLectura(9,'01/01/2011',1,290,rst);
altaLectura(9,'01/02/2011',1,291,rst);
altaLectura(9,'01/03/2011',1,292,rst);
altaLectura(9,'01/04/2011',1,293,rst);
altaLectura(9,'01/05/2011',1,294,rst);
altaLectura(9,'01/06/2011',1,295,rst);
altaLectura(9,'01/07/2011',1,296,rst);
altaLectura(9,'01/08/2011',1,297,rst);
altaLectura(9,'01/09/2011',1,298,rst);
altaLectura(9,'01/10/2011',1,299,rst);
altaLectura(9,'01/11/2011',1,300,rst);
altaLectura(9,'01/12/2011',1,301,rst);
altaLectura(10,'01/01/2011',1,500,rst);
altaLectura(10,'01/02/2011',1,501,rst);
altaLectura(10,'01/03/2011',1,502,rst);
altaLectura(10,'01/04/2011',1,503,rst);
altaLectura(10,'01/05/2011',1,504,rst);
altaLectura(10,'01/06/2011',1,505,rst);
altaLectura(10,'01/07/2011',1,506,rst);
altaLectura(10,'01/08/2011',1,507,rst);
altaLectura(10,'01/09/2011',1,508,rst);
altaLectura(10,'01/10/2011',1,509,rst);
altaLectura(10,'01/11/2011',1,510,rst);
altaLectura(10,'01/12/2011',1,511,rst);
end;
/*
select * from log
select * from contratos
select * from lecturas
select * from consumos
*/